      parameter (mmod=50000)
      real*8 acoff(2,10201)
      common/mapx/amap(mmod)
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename

c*** get block structure
      call blks(nblk)
      if(nblk.gt.mmod) then
        print *,'mmod needs increasing',mmod,nblk
        stop
      end if
      print *,'enter tomo file'
      read(5,'(a)') filename
      open(9,file=filename, form='unformatted')
      read(9) n,phibar
      read(9) iter,(amap(i),i=1,n),phibar,r
      close(9)
      print *,'enter output coefficient file'
      read(5,'(a)') filename
      open(22,file=filename, form='formatted')
     
      print *,'enter lmax'
      read(*,*) lmax
c*** now loop over coefficients from l=0 to l=lmax
      call wait(lmax,acoff)
      write(22,*) lmax
      lp=lmax+1
      ind=0
      do lp1=1,lp
        l=lp1-1
        do mp1=1,lp1
          m=mp1-1
          ind=ind+1
          write(22,900) l,m,acoff(1,ind),acoff(2,ind)
  900 format(2i5,2g24.16)
        enddo
      enddo
      close(22)
      stop
      end   

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename
      data rad/57.29578/
      print *,'enter block descriptor file : '
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end

      subroutine wait(lmax,acoff)                            
c*** use recursion to get expansion coefficients
c*** of the real map in array amap for harmonic degrees 0 to lmax
c*** output is in array acoff, lmax must be .le. 100
      implicit real*8(a-h,o-z)
      parameter (mmod=50000)
      real*4 amap,r1,r2,hsz,bsz
      common/mapx/amap(mmod)
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat

      dimension yfn(101),coff(2,101),acoff(2,*)
      data pi/3.14159265358979d0/

      rad=pi/180.d0    

c*** begin main loop over l from l=0 to lmax
      ind=0
      lp=lmax+1
      dt=bsz*rad
      do 1000 lp1=1,lp
        l=lp1-1
        do mp1=1,lp1
          coff(1,mp1)=0.d0
          coff(2,mp1)=0.d0                      
        enddo
c*** loop over colatitude 
        do i=1,nlat
          ml=mlat(i+1)-mlat(i)
          dl=hsz(i)*rad
          x1=(i-1)*dt
          x2=x1+dt
          call recur(x1,x2,l,yfn)
c          print *,i,(yfn(jj),jj=1,lp1)
c*** loop over longitude - add in contribution with the exp(imphi) integrals
c*** this next line is for m=0 which is a special case
          do j=1,ml
            coff(1,1)=coff(1,1)+dl*yfn(1)*amap(j+mlat(i))
          enddo
          do mp1=2,lp1
            m=mp1-1
            cc=cos(m*dl)-1.d0
            ss=sin(m*dl)
            do j=1,ml
              arg=(j-1)*m*dl
              co=cos(arg)
              si=sin(arg)
              sdt=(si*cc+co*ss)/m
              cdt=(co*cc-si*ss)/m
              dum1=amap(j+mlat(i))
              coff(1,mp1)=coff(1,mp1)+dum1*sdt*yfn(mp1)
              coff(2,mp1)=coff(2,mp1)+dum1*cdt*yfn(mp1)
            enddo
          enddo
        enddo
                                   
c*** store in output array
        do mp1=1,lp1
          ind=ind+1
          acoff(1,ind)=coff(1,mp1)
          acoff(2,ind)=coff(2,mp1)
        enddo

 1000 continue
      return
      end

      subroutine recur(r1,r2,l,xfn)
c*** use recurrence to compute int[thet1,that2] X sin (thet) dthet
      implicit real*8(a-h,o-z)
      dimension xfn(*),x(101),xp(101),dum(101)
      data pi/3.14159265358979d0/
      lp1=l+1  
      c1=cos(r1)
      c2=cos(r2)
      if(l.eq.0) then
        xfn(lp1)=(c1-c2)/dsqrt(4.d0*pi)      
        return
      endif
      s1=sin(r1)               
      s2=sin(r2)               
      call lfcn(l,c1,s1,x,dum)
      call lfcn(l,c2,s2,xp,dum)
      do i=1,lp1
        dum(i)=xp(i)*s2-x(i)*s1
      enddo
      xfn(l)=-sqrt(2.d0*l)*dum(lp1)/lp1
      if(l.eq.1) then
        xfn(lp1)=-0.5d0*sqrt(.375d0/pi)*(r2-r1-c2*s2+c1*s1)
      else
        xfn(lp1)=sval(l,r1,r2,c1,c2,s1,s2)
        lm1=l-1
        do mm=1,l-1
          m=l-mm
          fac1=(m+1)*sqrt((l+m)*(l-m+1.d0))
          fac2=(m-1)*sqrt((l-m)*(l+m+1.d0))
          xfn(m)=(fac2*xfn(m+2)-2.d0*m*dum(m+1))/fac1
        enddo
      endif
      return
      end

      real*8 function sval(l,r1,r2,c1,c2,s1,s2)
      implicit real*8(a-h,o-z)                                    
c*** compute int X(ll) sin(thet) dthet as starting point for
c*** recursion done in routine recur
      data pi4/12.56637061435916d0/
c*** compute scaling
      lp1=l+1
      fl2p1=l+lp1
      f=1.d0
      do i=1,l
        f=f*(i+i-1.d0)/(i+i)
      enddo
      fmult=sqrt(fl2p1*f/pi4)
      s11=s1*s1
      s22=s2*s2
      if(mod(l,2).eq.0) then
        ans=c1-c2
        s1c=c1
        s2c=c2
        do i=2,l,2
          s1c=s1c*s11
          s2c=s2c*s22
          ans=(s1c-s2c+i*ans)/(i+1)
        enddo
        sval=fmult*ans 
      else
        ans=0.5d0*(r2-r1-c2*s2+c1*s1)
        s1c=c1*s1
        s2c=c2*s2
        do i=3,l,2
          s1c=s1c*s11
          s2c=s2c*s22
          ans=(s1c-s2c+i*ans)/(i+1)
        enddo
        sval=-fmult*ans
      endif
      return
      end

      subroutine lfcn(l,c,s,x,x1)
c  computes ordinary spherical harmonics (Edmonds eqn 2.5.29)
c  using the Libbrecht algorithm
c    x(l,m,theta)*exp(imphi) are a set of orthonormal spherical 
c    harmonics where theta is colatitude and phi is longitude.
c  input:
c    l=harmonic degree
c    c=cos(theta)
c    s=sin(theta) 
c  output:
c    x(1) contains m=0, x(2) contains m=1, ... x(l+1) contains m=l
c    where m=azimuthal order 0.le.m.le.l .  
c    x1=dx/dtheta stored in the same way as x
c  calls no other routines
c       TGM
      implicit real*8(a-h,o-z)
      dimension x(*),x1(*)
      data pi4/12.56637061435916d0/
      lp1=l+1
      fl2p1=l+lp1
      con=sqrt(fl2p1/pi4)
c*** handle l=0
      if(l.eq.0) then
        x(1)=con
        x1(1)=0.d0
        return
      end if
c*** handle very small arguments
      if(abs(s).lt.1.d-20) then
        do i=1,lp1
          x(i)=0.d0
          x1(i)=0.d0
        enddo
        x(1)=con
        x1(2)=-0.5d0*con*sqrt(dble(l*lp1))
        return
      end if
c*** here is the Libbrecht algorithm
      c2=c+c
      f=1.d0
      do i=1,l
        f=f*(i+i-1.d0)/(i+i)
      enddo
      x(lp1)=con*sqrt(f)*(-1.d0)**l
      x1(lp1)=0.d0
      do i=1,l
        m=lp1-i
        mp1=m+1    
        f=sqrt(i*(fl2p1-i))
        x(m)=-(s*x1(mp1)+m*c2*x(mp1))/f
        x1(m)=s*x(mp1)*f
      enddo
      fac=1.d0
      do i=2,lp1
        x1(i)=(s*x1(i)+(i-1)*c*x(i))*fac
        x(i)=x(i)*s*fac
        fac=fac*s
      enddo
      return
      end
