      parameter (mmod=90000)
      common/amat1/amat(mmod),nmat(mmod)
      dimension x(mmod),resid(300000),resout(300000)
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename,filenam2
c*** get block structure
      call blks(nblk)
      if(nblk.gt.mmod) then
        print *,'mmod needs increasing',mmod,nblk
        stop
      end if
      write(*,'(a,$)') 'enter tomo file name: '
      read(5,'(a)') filename
      open(9,file=filename, form='unformatted')
      read(9),n,phibar
      print *,'enter desired iterate'
      read(5,*),niter
      do 5 k=1,niter
   5   read(9) iter,(x(i),i=1,n),phibar,r
      close(9)
      call modsiz(x,xlen)
      write(*,'(a,$)') 'enter matrix file name: '
      read(*,'(a256)') filename
      open(10,file=filename, form='unformatted')
      write(*,'(a,$)') 'enter multiplier for errors: '
      read(*,*) emult
      nscan=nshell
      chisq=0.d0
      ndat=0
      var1=0.
      var2=0.
      var1n=0.
      var2n=0.
      noutl=0
  10    read(10,end=30) dat,err,mm
        err=err*emult
        read(10) (amat(i),i=1,mm)
        read(10) (nmat(i),i=1,mm) 
        sum=0.
        do 20 i=1,mm
   20     sum=sum+amat(i)*x(nmat(i))
c***
        datn=dat/err
        sumn=sum/err
        var1n=var1n+datn*datn
        var2n=var2n+(datn-sumn)**2
        var1=dat*dat+var1
        var2=(dat-sum)**2+var2 
        chisq=chisq+((dat-sum)/err)**2
        ndat=ndat+1
        resid(ndat)=(dat-sum)/err
        if(abs(dat-sum)/err.gt.5) then
           noutl=noutl+1
           write(35,101) ndat,sum,dat,err,(dat-sum)/err
 101    format(i5,4f10.4)
        end if
      goto 10
   30 close(10)
      print *,' '
      print *,'model roughness = ',xlen
      print *,'number of data = ',ndat
      print *,'number of outliers = ',noutl
      print *,'chisq/N = ',chisq/ndat
      print *,'unnormalized variance reduction = ',1.-var2/var1
      print *,'normalized variance reduction = ',1.-var2n/var1n

c*** compute histogram and do statistics
      maxbin=500
      write(*,'(a,$)') 'output hist filename: '
      read(*,'(a256)') filenam2
      open(8,file=filenam2)
      print*,'enter bin width'
      read(*,*) bwid
    6 print*,'how many bins'
      read(*,*) nbins
      if (nbins.gt.maxbin) then
        print*,'must be less than',maxbin
        goto 6
      endif

c*** compute histogram
      call reshis(resid,ndat,bwid,nbins,resout,itot)

c*** compute the usual statistics
      call getstat(resout,itot,dmed,errmed,dmean,std,errmean,ierr)
      print*,'there are ',itot,' residuals within histogram limits'
      if (ierr.eq.0) then
c*** this is for scaled median absolute deviation (smad)
        emed=errmed/0.6745
        emedn=emed/sqrt(float(itot))
        write(*,'(a,4x,3f12.5)') 'mean & err & std  = ',dmean,errmean
     +     ,std
        write(*,'(a,3f12.5)') 'median & smadn & SMAD = ',dmed,emedn,
     &                        emed
      endif

      stop
      end   

      subroutine modsiz(x,xlen)
c*** computes roughness of model x, returned in xlen
      dimension x(*),amat(5),nmat(5)
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat

      xlen=0.
      j=1
      jmx=j*mshell
      jmn=jmx-mshell+1
      do 50 i=1,mshell
        ib=(j-1)*mshell+i
        call iblk(r0,t0,p0,ib)
c*** get N-S neighbors
        tx=t0+bsz
        px=p0
        if(tx.gt.180.) then
           tx=t0
           px=p0+180.
           if(px.gt.360.) px=px-360.
        end if
        call fblk(r0,tx,px,jbs)
        nmat(1)=max(min(jbs,jmx),jmn)
        tx=t0-bsz
        px=p0
        if(tx.lt.0.) then
            tx=-tx
            px=p0+180.
           if(px.gt.360.) px=px-360.
        end if
        call fblk(r0,tx,px,jbn)
        nmat(2)=max(min(jbn,jmx),jmn)
c*** get E-W neighbors
        it=t0/bsz+1
        px=p0-hsz(it)
        if(px.lt.0.) px=px+360.
        call fblk(r0,t0,px,jbw)
        nmat(3)=max(min(jbw,jmx),jmn)
        px=p0+hsz(it)
        if(px.gt.360.) px=px-360.
        call fblk(r0,t0,px,jbe)
        nmat(4)=max(min(jbe,jmx),jmn)
        sum=4.*x(ib)
        do k=1,4
          sum=sum-x(nmat(k))
        enddo
        xlen=xlen+sum**2
   50   continue
      xlen=sqrt(xlen)
      return
      end

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename
      data rad/57.29578/
      print *,'enter block descriptor file : '
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end

      subroutine fblk(r0,t0,p0,ib)
c*** routine to find block number given radial index and colat and long
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      do 10 i=1,nshell
      if(r0.ge.r1(i).and.r0.le.r2(i)) then
         n=i
         goto 20
      end if
   10 continue
      ib=-1
      return
   20 it=t0/bsz+1
      if(it.ge.1.and.it.le.nlat) then
        j1=(n-1)*mshell+mlat(it)+1
        ib=p0/hsz(it)+j1
      else
        ib=-1
      end if
      return
      end

      subroutine iblk(r0,t0,p0,ib)
c*** routine to find radius,colat and long of middle of block ib
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      kshell=float((ib-1))/float(mshell)+1
      r0=0.5*(r1(kshell)+r2(kshell))
      do 10 i=1,nlat
        j1=(kshell-1)*mshell+mlat(i)+1
        j2=(kshell-1)*mshell+mlat(i+1)
        if(ib.ge.j1.and.ib.le.j2) then
          t0=(i-0.5)*bsz
          p0=(ib-j1+0.5)*hsz(i)
          return
        end if
   10 continue
      r0=-1
      return
      end

      subroutine reshis(resid,inum,bwid,nbins,resout,itot)
c A subroutine to make Histograms from any sort of data.
c Writes output to unit 8 (assumes 8 is open for formatted output) in
c a form suitable for xyplot.
c Let x be an element of resid. Then:
c The zero bin is for x| -bwid/2 < x < bwid/2, etc.
c The n'th positive bin is for x| n*bwid-(bwid/2)<= x < n*bwid+(bwid/2), etc.
c The n'th negative bin is for x| -n*bwid-(bwid/2)< x <= -n*bwid+(bwid/2), etc.
c  input:
c    resid = data array to be binned.
c    inum  = # of elements in resid
c    bwid  = bin width
c    nbins = # of bins (nbins positive bins, nbins negative bins + 1 zero bin).
c  output:
c    itot  = actual # of elements of resid that fall within bin limits
      dimension resid(*),resout(*),npos(500),nneg(500)
      integer zero
      maxbin = 500
      if (nbins.gt.maxbin) return
      bwid2 = bwid/2.0
      itot  = 0
      zero  = 0
      nzer  = 0
      do i=1,maxbin
        npos(i) = 0
        nneg(i) = 0
      enddo
      do 10 i=1,inum
      nbin=resid(i)/bwid2
      if (nbin.eq.0) then
        nzer = nzer + 1
      else
        ibin=iabs(nbin)
        ntest=ibin/2
        if ((ntest*2).ne.ibin) then
          ibin=(ibin+1)/2
        else
          ibin=ibin/2
        endif
        if (ibin.gt.nbins) goto 10
        if (nbin.gt.0) then
          npos(ibin)=npos(ibin)+1
        else
          nneg(ibin)=nneg(ibin)+1
        endif
      endif
      itot=itot+1
      resout(itot)=resid(i)
   10 continue
c ** write out the negative bins
      do i=nbins,1,-1
         x1 = (-i*bwid) - bwid2
         x2 = x1+bwid
         write(8,501) x1, zero
         write(8,501) x1, nneg(i)
         write(8,501) x2, nneg(i)
         write(8,501) x2, zero
      enddo
c ** write out the zero bin
      x1 = zero-bwid2
      x2 = x1+bwid
      write(8,501) x1, zero
      write(8,501) x1, nzer 
      write(8,501) x2, nzer
      write(8,501) x2, zero
c ** write out the positive bins
      do 30 i=1,nbins
      x1 = (i*bwid)-bwid2
      x2 = x1+bwid
      write(8,501) x1, zero
      write(8,501) x1, npos(i)
      write(8,501) x2, npos(i)
   30 write(8,501) x2, zero
c ** write out line across bottom of histogram
      write(8,501) (-nbins*bwid-bwid2), zero
  501 format(f20.5,5x,i10)
      return
      end

      subroutine shell(a,ncol)
c  shell sorts a(nc) into increasing order
      dimension a(ncol)
      ig=ncol
    5 if(ig.le.1) return
      ig=ig/2
      im=ncol-ig
   10 iex=0
      do 20 i=1,im
      ipg=i+ig
      if(a(i).le.a(ipg)) go to 20
      te=a(i)
      a(i)=a(ipg)
      a(ipg)=te
      iex=iex+1
   20 continue
      if(iex.gt.0) go to 10
      go to 5
      end

      subroutine getstat(d,num,dmed,errmed,dmean,dstd,errmean,ierr)
c Computes statistics of array d.
c  input:
c    d   = array of length num
c    num = length of array d
c  output:
c    dmed    = median value of d
c    errmed  = error of median
c    dmean   = mean of array d
c    dstd    = standard deviation of array d
c    errmean = uncertainty of estimated mean of d
c    ierr    = error flag = 0 if no errors in input or output
      dimension d(*)
      common/misc2/e(300000)
      real*8 avg,var
      ierr = -1
      if (num.le.1) return
      if (num.gt.300000) then
        write(*,*) 'warning -- max dim of stat subroutine exceeded'
        return
      endif
      pts = float(num)
      do i=1,num
         e(i)=d(i)
      enddo
c get mean
      avg=0.d0
      do i=1,num
         avg = avg + e(i)
      enddo
      dmean = avg / pts
c get variance
      var = 0.d0
      do i=1,num
         var = var + (e(i)-dmean)**2
      enddo
      var = var / (pts-1.0)
c standard deviation of distribution
      dstd = sqrt(var)
c error of mean
      errmean = sqrt(var/pts)
c median
      call shell(e,num)
      j = num / 2
      if ( (j*2).eq.num ) then
        dmed = ( e(num/2)+e(num/2+1) )/2.0
      else
        dmed = e((num/2) + 1)
      endif
c error of median (median absolute devitaion)
      do i=1,num
        e(i) = abs(dmed-e(i))
      enddo
      call shell(e,num)
      j = num / 2
      if ( (j*2).eq.num ) then
        errmed = ( e(num/2)+e(num/2+1) )/2.0
      else
        errmed = e((num/2) + 1)
      endif
      ierr = 0
      return
      end

