c
c     This program will calculate the correlation coefficient betweeen two
c     splitting functions and between the different degrees in the splitting.
c     the correlation is just the inner product of the two complex fuctions
c     on the sphere, normalized by the power. 
c
c  y(l,-m)=(-1)**m*y(l,m)bar, where y(l,m)bar = complex conjugate of y(l,m)
c  c(l,-m)=(-1)**m*c(l,m)bar 
c  for negative m's cj(l,-m) * dj(l,-m)bar = cj(l,m)bar * dj(l,m)
c  for positive m's cj(l,m)  * dj(l,m)bar = cj(l,m) * dj(l,m)bar (of course)
c
c
      implicit real*8(a-h,o-z)
      dimension acoff(2,5151),bcoff(2,5151)
      data pi/3.14159265358979d0/
      con=4.*pi
c                    
      call readcf(lmaxa,acoff)
      call readcf(lmaxb,bcoff)
      print *,'enter scale factor for second set of coffs'
      read(*,*) scal 
      scal2=scal*scal
      lmax=min0(lmaxa,lmaxb)
      lp1=lmax+1
c
      pow1t=0.d0
      pow2t=0.d0
      cpowrt=0.d0
c           
c  compute cross-correlations, looping over all harmonic degrees
      ibeg=1
      do 20 i=1,lp1
      l=i-1
      iend=ibeg+l
      pow1=acoff(1,ibeg)*acoff(1,ibeg)
      pow2=bcoff(1,ibeg)*bcoff(1,ibeg)*scal2
      cpowr=acoff(1,ibeg)*bcoff(1,ibeg)*scal
      if(l.eq.0) goto 15
      do 10 j=ibeg+1,iend
      pow1=pow1+2.*(acoff(1,j)*acoff(1,j)+acoff(2,j)*acoff(2,j))
      pow2=pow2+2.*(bcoff(1,j)*bcoff(1,j)+bcoff(2,j)*bcoff(2,j))*scal2
  10  cpowr=cpowr+2.*(acoff(1,j)*bcoff(1,j)+acoff(2,j)*bcoff(2,j))*scal
c
c accumulate totals
  15  pow1t=pow1t + pow1
      pow2t=pow2t + pow2
      cpowrt=cpowrt + cpowr
      den=dsqrt(pow1*pow2)
      if(den.ne.0.d0) then
        cross=cpowr/den    
      else
        cross=0.d0
      endif
      fl1=(l+l+1)*con
      amp1=sqrt(pow1/fl1)
      amp2=sqrt(pow2/fl1)
      print 900,l,cross,amp1,amp2,amp1/amp2
      write(55,900) l,cross,amp1,amp2,amp1/amp2
  900 format(i5,4g14.6)
      ibeg=iend+1
   20 continue
c             
      ccorr=cpowrt/dsqrt(pow1t*pow2t)
      print 901,ccorr,pow1t,pow2t
  901 format(5x,3g14.6)
c     
      stop
      end
      
      subroutine readcf(lmax,acoff)
      implicit real*8(a-h,o-z)
      dimension acoff(2,*)
      character*256 filnam
c
c ** open files, etc.
      print *,'input harmonic file name : '
      read(*,'(a)') filnam
      open(8,file=filnam,status='old')
      read(8,*) lmax
      istop = (lmax+1)*(lmax+2)/2
      do ind=1,istop
         read(8,*,end=20) l,m,acoff(1,ind),acoff(2,ind)
      enddo
c
   20 close(8)     
   90 return
      end
