      common/blocks/r1(100),r2(100),hsz(1800),bsz,
     +    nshell,mshell,mlat(1801),nlat
      common/map/amap(720,360)
      character*256 filename
      dimension block(200000),dum(2000)
      call blks(nblk)

      read(5,'(a)') filename
      open(9,file=filename, form='unformatted')
      read(9),n,phibar
      read(5,*),niter
      do 10 k=1,niter
   10   read(9) iter,(block(i),i=1,n),phibar,r
      close(9)
      open(8,file='out.map')
      open(9,file='out.map0')

      nlong=2*nlat

      if(nshell.ne.1)then
        print*,'sorry, wrong plotting code'
        stop
      endif
      sum=0.
      do i=1,nblk
         sum=sum+block(i)
      enddo
      sum=sum/nblk
      write(33,*)'spherical average: ',sum
      do 40 i=1,nshell
        r0=0.5*(r1(i)+r2(i))
        do 41 j=1,nlat
          t0=(j-.5)*bsz
          do 42 k=1,nlong
            p0=(k-0.5)*bsz
            call fblk(r0,t0,p0,ib)
            amap(k,j)=block(ib)
   42       continue
   41     continue
        do 51 j=1,nlat
        do 51 k=1,nlong
   51     amap(k,j)=amap(k,j)-sum
      nh=nlong/2
      do j=1,nlat
        write(8,910) (amap(k,j),k=1,nlong)
        do ii=1,nh
          dum(ii)=amap(ii+nh,j)
          dum(ii+nh)=amap(ii,j)
        enddo
        write(9,910) (dum(k),k=1,nlong)
      enddo
  910 format(40(9e15.5/))
   40 continue
      close(8)
      close(9)
      stop
      end

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(100),r2(100),hsz(1800),bsz,
     +    nshell,mshell,mlat(1801),nlat
      character*256 filename
      data rad/57.29578/
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat                  
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end

      subroutine fblk(r0,t0,p0,ib)
c*** routine to find block number given radial index and colat and long
      common/blocks/r1(100),r2(100),hsz(1800),bsz,
     +    nshell,mshell,mlat(1801),nlat
      do 10 i=1,nshell
      if(r0.ge.r1(i).and.r0.le.r2(i)) then
         n=i
         goto 20
      end if
   10 continue
      ib=-1
      return
   20 it=t0/bsz+1
      if(it.ge.1.and.it.le.nlat) then
        j1=(n-1)*mshell+mlat(it)+1
        ib=p0/hsz(it)+j1
      else
        ib=-1
      end if
      return
      end

      subroutine iblk(r0,t0,p0,ib)
c*** routine to find radius,colat and long of middle of block ib
      common/blocks/r1(100),r2(100),hsz(1800),bsz,
     +    nshell,mshell,mlat(1801),nlat
      kshell=float((ib-1))/float(mshell)+1
      r0=0.5*(r1(kshell)+r2(kshell))
      do 10 i=1,nlat
        j1=(kshell-1)*mshell+mlat(i)+1
        j2=(kshell-1)*mshell+mlat(i+1)
        if(ib.ge.j1.and.ib.le.j2) then
          t0=(i-0.5)*bsz
          p0=(ib-j1+0.5)*hsz(i)
          return
        end if
   10 continue
      r0=-1
      return
      end


