c*** this is description of what is in the Harvard phase files
c 1.  The name of the event in the CMT catalog, mmddyyX.
c 2.  The name of the station.
c 3.  Epicentral latitude (CMT centroid)
c 4.  Epicentral longitude (CMT centroid)
c 5.  Hypocentral depth (CMT centroid)
c 6.  Station latitude
c 7.  Station longitude
c 8.  measured d(phase velocity) in km/s (w.r.t. PREM)
c 9.  The length of the path in km
c 10. The phase anomaly in radians
c 11. Quality index 1
c 12. Quality index 2
c 13. Quality index 3
c 14. Wave type - R=Rayleigh, L=Love
c 15. The period of the measurement
c 16. The minimum period of the dispersion curve for this measurement
c 17. The maximum period of the dispersion curve for this measurement
c 18. Predicted phase anomaly (initially 0)
c 19. Weight of this measurement (0=skip, outlier;  1=OK, to be used)
c 20. Weight of this measurement (=1.0/sigma) where sigma is the
c     uncertainty expressed in terms of the phase (in radians)
      implicit real*8(a-h,o-z)
      character*256 filename
      character*160 string
      character*7 cmtname
      character*8 stat
      character*1 wavetype
c
      real*4 row,t1,p1,dc,errc
      character*256 filenam2
      character*4 nsta
      dimension block(50000)
      common row(50000),nrow(50000)
      data pi/3.14159265358979d0/
      rad=pi/180.d0   
        fac=2.*pi*6371./360.
      call blks(nblk)
      print *,nblk
      write(*,'(a,$)') 'output matrix name: '
      read(*,'(a256)') filenam2
      open(10,file=filenam2, form='unformatted')
      print *,'enter phase file name : '
      read(*,'(a)') filename
      print *,'enter ref. phase velocity : '
      read(*,*) cref
      open(7,file=filename, form='formatted')
c*** first line is junk
      read(7,"(a)") string
      nproc=0
c*** loop over rest of file
   10 continue
      read(7,"(a)",end=25) string
      read(string,"(a7,1x,a8,f8.3,f9.3,f6.1,f8.3,f9.3,f8.4,f8.1,f8.3,
     #     1x,f6.3,1x,f6.3,1x,f6.3,1x,a1,3f6.1,f8.3,1x,f5.3,1x,f5.3)")
     #     cmtname,stat,cmtlat,cmtlon,cmtdep,
     #     stlat,stlon,delc,distance,dphase,
     #     wfit,sfit,bfit,wavetype,
     #     period,periodmin,periodmax,predphase,weight,weight2
        if(weight.le.0.) goto 10
        if(weight2.le.0.) goto 10
        do i=1,nblk
          row(i)=0.
        enddo
        om=2.*pi/period
        arg=om*distance*delc/dphase
        if(arg.ge.0.) goto 10
        cvel=sqrt(-arg)
        dc=delc/cref
        errc=cref/(om*distance*weight2)
        nsta(1:4)=stat(1:4)
        if(nsta(4:4).eq.'-') nsta(4:4) =' '
        if(nsta.eq.'PFOT') nsta='PFO '
        if(nsta.eq.'PFO_') nsta='PFO '
        if(nsta.eq.'IPAS') nsta='PAS '
        if(nsta.eq.'GRI ') goto 10
        norb=1
        t0=(90.-cmtlat)*rad
        p0=cmtlon*rad
        t0=geocen(t0)
        read(nsta,'(a4)')jsta
        call allnsta(jsta,t1,p1)
        ts=t1
        ps=p1
        ts=geocen(ts)
        call sray(t0,p0,ts,ps,norb,delt)
        nels=0
        sum=0.
        do i=1,nblk
          if(row(i).ne.0) then
            nels=nels+1
            nrow(nels)=i
            row(nels)=row(i)/delt
            sum=sum+row(nels)
            row(nels)=row(nels)*.01
          end if
        enddo
        dist=distance/fac
        nproc=nproc+1
        if(mod(nproc,100).eq.0) then
        print 999,sum,delt,delt*sum,dist,dc,errc,cvel
  999   format(7g14.6)
        end if
c*** write out matrix row here
        if(abs(sum-1.d0).gt.0.005d0) then
          print *,'skipping datum'
          goto 10
        end if
        nscan=nels
        inum=inum+1
        write(10) dc,errc,nscan
        write(10) (row(i),i=1,nscan)
        write(10) (nrow(i),i=1,nscan) 
      goto 10
   25 close(7)
      close(10)
      stop
      end

      subroutine sray(sth,sph,rth,rph,norb,delt)
      implicit real*8(a-h,o-z)
      real*4 row
      common row(50000),nrow(50000)
      data pi/3.14159265358979d0/
      r0=6371.
      rad=pi/180.d0   
      tpi=2.d0*pi
c*** great circle data has gc pole where source loc usually is
      if(norb.lt.10) then
        call eulerf(sth,sph,rth,rph,alpha,beta,gamma,delta)
      else
        beta=sth
        alpha=sph
        gamma=0.
      end if
c***  alpha, beta and gamma are Euler angles
      calf=cos(alpha)
      salf=sin(alpha)
      cbet=cos(beta)
      sbet=sin(beta)
      cgam=cos(gamma)
      sgam=sin(gamma)
      if(norb.gt.10) then
        delta=tpi
      else
        if(mod(norb,2).eq.1) then
           delta=delta+(norb-1)*pi
        else
          delta=delta-norb*pi
        end if
      end if
      delt=abs(delta)/rad
c*** note that delta is negative for even norb
      dp=0.01*rad
      if(delta.lt.0.d0) dp=-dp
      ps=0.
c*** move around equator
    5   if(ps.eq.delta) return
        ps0=ps
        ps=ps+dp
        if(dp.lt.0..and.ps.lt.delta) ps=delta
        if(dp.gt.0..and.ps.gt.delta) ps=delta
        delp=abs(ps-ps0)
c*** convert to cartesian
        x=cos(ps)
        y=sin(ps)
c*** use euler angles to rotate to geographic
        t1=cgam*x-sgam*y
        t2=sgam*x+cgam*y
        u1=cbet*t1
        z=-sbet*t1
        x=calf*u1-salf*t2
        y=salf*u1+calf*t2
        call sphr(x,y,z,r,t,p)
        t0=t/rad
        p0=p/rad
        call fblk(r0,t0,p0,ib)
        row(ib)=row(ib)+delp/rad
      goto 5
      end
      
      subroutine eulerf(sth,sph,rth,rph,alpha,beta,gamma,del)
c   Finds the Euler angles alpha,beta,gamma that rotate the coordinate axes 
c   so that the z-axis is at the pole of the source-receiver great circle 
c   (s x r), and the x-axis is at the source. See Edmonds' Angular Momentum 
c   in Quantum Mechanics, page 7 for the angle conventions.
c     input: sth,sph = source coordinates in radians
c            rth,rph = receiver coordinates in radians
c     output: alpha,beta,gamma = euler angles in radians which rotate the 
c             original coordinate system to the one with the source-receiver 
c             great circle on the equator, the source at (PI/2,0). The minor 
c             arc to the receiver is in the positive phi direction.
c            del = source-receiver separation in radians.
c            pth,pph = source-receiver great circle pole location.
      implicit real*8(a-h,o-z)
      data pi/3.14159265358979d0/
c  Get cartesian coordinates for source and receiver
      call cart(sth,sph,sx,sy,sz)
      call cart(rth,rph,rx,ry,rz)
      del = dacos(sx*rx + sy*ry + sz*rz)          
      call cross(sx,sy,sz,rx,ry,rz,px,py,pz)
      pth = datan2(dsqrt(px*px+py*py),pz)
      if(px.eq.0. .and. py.eq.0.) then
c  special case of pole at z or -z
         pph = 0.
      else
         pph = datan2(py,px)
      endif
      alpha = pph
      beta = pth
c  the x'' axis (call it t) is at pth+pi/2,pph
      ttheta = pth + pi/2.
      call cart(ttheta,pph,tx,ty,tz)
c  the third Euler angle, gamma, rotates x'' to the source s.
      gamma = dacos(sx*tx + sy*ty + sz*tz)
c  form q = x'' x s to check the sign of gamma (q/|q| = +-p/|p|)
      call cross(tx,ty,tz,sx,sy,sz,qx,qy,qz)
      sgn = px*qx + py*qy + pz*qz
      if(sgn .lt. 0.) gamma = -gamma
      return
      end
 
      subroutine cart(thet,phi,x,y,z)
      implicit real*8(a-h,o-z)
      s=dsin(thet)
      x=s*dcos(phi)
      y=s*dsin(phi)
      z=dcos(thet)
      return
      end 
 
      subroutine cross(sx,sy,sz,rx,ry,rz,px,py,pz)
      implicit real*8(a-h,o-z)
      px = sy*rz - sz*ry                         
      py = sz*rx - sx*rz
      pz = sx*ry - sy*rx      
      return
      end

      subroutine sphr(x,y,z,r,t,p)
c  compute spherical coordinates (r,t,p) from cartesian coordinates (x,y,z). t is
c  colatitude and p is longitude in radians. p is returned in the interval (0,2*pi).
      implicit real*8(a-h,o-z)
      data pi/3.14159265358979d0/
      r=sqrt(x*x+y*y+z*z)
      if(r.gt.0.) goto 2
      t=0.
      p=0.
      return
    2 t=sqrt(x*x+y*y)
      t=atan2(t,z)
      if(x.eq.0.) goto 4
      p=atan2(y,x)
      if(p.lt.0.) p=p+2.*pi
      return
    4 continue
      if(y.lt.0.) then
         p=1.5*pi
      else if(y.eq.0.) then
         p=0.
      else
         p=0.5*pi
      end if
      return
      end   

      subroutine blks(nblk)
c*** routine to establish block parameters
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      character*256 filename
      data rad/57.29578/
      print *,'enter block descriptor file : '
      read(*,'(a)') filename
      open(12,file=filename)
      read(12,*) bsize
      nlat=nint(180./bsize)
      bsize=180./nlat
      bsz=bsize
      read(12,*) nshell
      ib=0
      do 10 n=1,nshell
        read(12,*) rad1,rad2
        tmax=0.
        r1(n)=rad1
        r2(n)=rad2
        mlat(1)=0
        do 30 ii=1,nlat                  
        tmin=tmax
        tmax=tmin+bsize
        th=0.5*(tmin+tmax)/rad
        s1=sin(th)
        mlon=max(nint(360./bsize*s1),1)
        hsize=360./mlon
        ib=ib+mlon
        if(n.eq.1) then
           hsz(ii)=hsize
           mlat(ii+1)=ib
        end if
   30   continue
      if(n.eq.1) mshell=ib
   10 continue
      nblk=ib
      close(12)
      return
      end

      subroutine fblk(r0,t0,p0,ib)
c*** routine to find block number given radial index and colat and long
      real*8 r0,t0,p0
      common/blocks/r1(30),r2(30),hsz(180),bsz,
     +    nshell,mshell,mlat(181),nlat
      do 10 i=1,nshell
      if(r0.ge.r1(i).and.r0.le.r2(i)) then
         n=i
         goto 20
      end if
   10 continue
      ib=-1
      return
   20 it=t0/bsz+1
      if(it.ge.1.and.it.le.nlat) then
        j1=(n-1)*mshell+mlat(it)+1
        ib=p0/hsz(it)+j1
      else
        ib=-1
      end if
      return
      end

      double precision function geocen(arg)
c Returns geocentric colat given geographic colat as arg (n.b. fac=(1-f)**c
c argument in radians.
      implicit real*8(a-h,o-z)
      data pi2,fac/1.570796326794895d0,0.993305621334896d0/
      geocen=pi2-datan(fac*dcos(arg)/dmax1(1.d-200,dsin(arg)))
      return
      end

      subroutine allnsta(nsta,th,ph)
      parameter(lsta=10000)
      character*2 dtype(lsta)
      character*40 dname(lsta)
      integer*4 dsta(lsta)
      dimension dlat(lsta),dlon(lsta),delev(lsta)
      dimension ddep(lsta)
      save
      data rad,ifirs/.017453293,0/
      th=0.
      ph=0.
      istat=0
      if(ifirs.eq.1)goto 1
  
      open(51,file='stations',status='old')
      j=0
 2    continue
      j=j+1
      read(51,101,end=99)dsta(j),dtype(j),dlat(j),
     +     dlon(j),delev(j),ddep(j),dname(j)
      if(dlon(j).lt.0.)dlon(j)=dlon(j)+360.
      goto 2
 99   continue
      close(51)
      ifirs=1
      ndat=j-1
 1    continue
      do 10 i=1,ndat
      if(nsta.eq.dsta(i))then
          istat=1  
          th=rad*(90.-dlat(i))
          ph=rad*dlon(i)
          return
      endif
 10   continue
      print 100,' station not found: ',nsta
 101  format(a4,4x,a2,3x,2f11.4,f8.0,f5.0,17x,a40)
 100  format(a,a4,1x,a4)
      return
      end

