cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
                     Program COLOR
*  Use only in debugging on sun/4
*#include <f77/f77_floatingpoint.h>
c
c$$$$ calls getmat,getone,major,peruse
c
c  Main program for color contouring of rectangular arays.
c  Program runs under a simple interpretive language with commands
c  like
c    file topography
c    read 43 55
c  See color.doc for a complete description.
c  The program generates a PostScript file for plotting.
c
c  The principle of the program is to describe all the boundaries of
c  the different colored regions (the contour lines) which are forced
c  to be closed curves.  These closed polygons are filled with the 
c  appropriate color using the PostScript "fill" command.  Of course
c  this must be done in a proper order to prevent covering up previously
c  drawn regions; the program plots in order of decreasing regional
c  area.
c
c  Language interpretation is handled by the routines  peruse,
c  getval,  getchr.  Peruse reads in all commands up to certain
c  key points (read or plot), saving the list in a character array
c  for subsequent analysis by getval and getchr.  These routines
c  are called whenever values or strings are needed at the appropriate
c  point in the program.
c
c  There are essentially 7 separate program units:
c  (1) the main program, start up and quit routines.
c  (2) the language unit 			(peruse.f)
c  (3) the array input routines 		(getmat.f)
c  (4) the map generator and page manager 	(major.f)
c  (5) the contour line generating algorithm 	(glevel.f)
c  (6) the level-line output handler		(dumpit.f)
c  (7) the color palette data base 		(artist.f)
c
      parameter (inmx=400)
      character *80 input(inmx), output
      common /dicta/ input
      common /outfil/ output
      common /ndict/ iecho,nin,istate(inmx)
c
      parameter (maxa=907 000)
      common // a(maxa)
c
      common /xtreme/ bord,amin,amax,anull(2),alim(3),colim(2)
      common /inout/ inp,iout,inf,info
c
      parameter (levmx=50)
      common /noir/ scutum,kolors,art(4,levmx),kart(levmx),loutln(levmx)
c
      common /atlas/ map,mtab,ntab,xtab(201),ytab(201)
c
      data ihead/1/
c
ce
*     ieeer= ieee_handler('set','common',SIGFPE_ABORT)
*     iecho=1
c  
c  
      do 5000 k=1, inmx
c  Read commands up to 'plot', 'read' or 'quit'
        call peruse(ihead)
        call getone('verbose', verb, nf)
        if (nf .eq. 1) info=verb
c
c  Input the array
        call getmat(m, n, a)
        ihead=0
        if (input(nin)(1:4) .eq. 'read') goto 5000
c
c  Draw the map
        call major(m+2, m, n, a)
        ihead=1
 5000 continue
      end
c______________________________________________________________________
      subroutine quit
c$$$$ calls getone, system
c  Brings program to an orderly conclusion;
c  Send file to screen if requested.
c  CAUTION: "system" is a SUN routine to invoke a UNIX shell and
c           show is local window display utility.  
c           Users on other systems delete the line containing system
c           below
      character*80 output
      common /outfil/ output
      common /inout/ inp,iout,inf,info
c
      write(9, '(a)')'showpage'
      close (unit=9)
      call getone('show', dum, nshow)
c  CAUTION: Next line is system-dependent!
      if (nshow .ge. 0) call system('show < '//output)
      write(iout,'(a)')' ',' Normal termination'
      stop
      end
c______________________________________________________________________
      blockdata start
c
      parameter (inmx=400)
      common /ndict/ iecho,nin,istate(inmx)
      common /xtreme/ bord,amin,amax,anull(2),alim(3),colim(2)
      common /inout/ inp,iout,inf,info
c
      data iecho/0/, nin/0/
      data anull /0,0/, alim/0,0,0/
c
c inp=std input; iout=std output; inf=array diskfile; info=print freq
      data inp/5/,       iout/6/,             inf/7/, info/1/
c
      end
c______________________________________________________________________
*=======================================================================
* Level-line output handler   BEGIN=====================================
*
      subroutine dumpit(val, nxy, xx, yy)
c$$$$ calls mapper
c  Saves in common /arcs/ the vector kxy, which contains closed
c  contour loops as they are generated; also saves path area and 
c  inside color value.  Calls mapper to transform saved lines to
c  their new coordinate plane.
c
c     Arguments
c  val    is the current contour level
c  nxy    is the number of points defining the contour, which is
c         always closed
c  xx,yy are arrays containing the points on the contour; these are
c        such that a grid step is one unit in each, (0,0) is the top
c        left corner, x increases with i, the row counter, and y with
c        j the column counter.
c
      dimension xx(*),yy(*)
      parameter (lpmx=250000, knmx=300000)
      integer*2 kxy
      common /perim/ ltrue(lpmx)
      common /arcs/ loops,istart(lpmx),area(lpmx),lev(lpmx),kxy(2,knmx)
      common /trace/ level,em,en,xfac,yfac
c
      parameter (maxa=907 000)
      common // a(maxa)
c
      common /inout/ inp,iout,inf,info
c
c  Advance the loop counter; save next start position; trap errors
      loops=loops+1
      if (loops .gt. lpmx) then
        write(iout,'(a)') ' ',
     $  '!!!! Sorry - too many contour paths. Either reduce number',
     $  'of  levels  or  recompile  with  increased parameter LPMX'
        stop
      endif
c
c  Calculate -2*area of this loop.
      surf=0.0
      xx(nxy+1)=xx(1)
      yy(nxy+1)=yy(1)
      do 1100 i=2, nxy+1
        surf=surf + (xx(i)*yy(i-1) - xx(i-1)*yy(i))
 1100 continue
      area(loops)=-abs(surf)
c
c  Discover which color lies INSIDE contour: midf= +1 if high values
c  inside, -1 for low values
c  Move along contour until one of coordinates lies on a grid line.
      do 1200 i=1, nxy-1
        if (nint(xx(i)).eq.xx(i) .or. nint(yy(i)).eq.yy(i)) goto 1210
 1200 continue
      i=1
 1210 i1=nint(xx(i) + 1.0)
      j1=nint(yy(i) + 1.0)
      ij=(j1-1)*(em+2.0) + i1
      midf=sign(1.0, ((yy(i+1)-yy(i))*(i1-1.0- xx(i)) -
     $(xx(i+1)-xx(i))*(j1-1.0 - yy(i)))*(a(ij) - val)*surf)
      lev(loops)=max(1, level + (midf - 1)/2)
      ltrue(loops)=level
c
c  Convert to thousandths of an inch and store in common /arcs/;
c  constrain path to lie within or on boundary of inner rectangle
      j=istart(loops)
      call mapper(kxy(1,j), xx(1), yy(1))
      j=j+1
      call mapper(kxy(1,j), xx(2), yy(2))
c  From this point on, remove long runs of constant x or y values which 
c  arise in the border
      do 1500 i=3, nxy
        j=j+1
        call mapper(kxy(1,j), xx(i), yy(i))
        if (kxy(1,j).eq.kxy(1,j-2) .and. kxy(1,j).eq.kxy(1,j-1)) then
          kxy(1,j-1)=kxy(1,j)
          kxy(2,j-1)=kxy(2,j)
          j=j - 1
          goto 1500
        endif
        if (kxy(2,j).eq.kxy(2,j-2) .and. kxy(2,j).eq.kxy(2,j-1)) then
          kxy(1,j-1)=kxy(1,j)
          kxy(2,j-1)=kxy(2,j)
          j=j - 1
          goto 1500
        endif
 1500 continue
c
      istart(loops+1)=j + 1
      if (istart(loops+1) .ge. knmx) then
        write(iout,'(a)') ' ',
     $  '!!!! Sorry - total length of contour lines is too long.  Use',
     $  'fewer contour levels or recompile with bigger parameter KNMX'
        stop
      endif
c
      return
      end
c_______________________________________________________________________
      blockdata mappng
      common /atlas/ map,mtab,ntab,      xtab(201),  ytab(201)
      data       map/1/, mtab,ntab/0,0/, xtab/201*1/,ytab/201*1/
      end
c_______________________________________________________________________
      subroutine mapper(kxy, xp, yp)
c$$$$ calls aitoff
c  Maps the point (xp, yp) into 1/1000 inch scaled version.
c  Values of xp are forced into the interval (1,em) and 
c  yp into (1,en);  the scale factors and limits common through /trace/
c
c  Choice of map comes through /atlas/ in map.
      integer*2 kxy
      dimension kxy(*)
      common /trace/ level,em,en,xfac,yfac
      common /atlas/ map,mtab,ntab,xtab(201),ytab(201)
c
c  Constrain coordinate to lie within the true array, sans border.
      x=max(1.0, min(em, xp))
      y=max(1.0, min(en, yp))
c
c  Select the mapping
      goto (1000, 2000, 3000), map
c
c  The identity mapping for our purposes.  Note the conversion to
c  integer*2 thousandths of an inch.
 1000 kxy(1)=xfac*x
      kxy(2)=yfac*y
      return
c
c  Aitoff equal-area from presumed scaled long-lat input pairs
 2000 alat =179.9*(y-1.0)/(en-1.0) - 89.95
      along=359.9*(x-1.0)/(em-1.0) -179.95
      call aitoff(alat, along, x, y)
      x=1.0 + (em-1.0)*(0.25*x + 0.5)
      y=1.0 + (en-1.0)*(0.50*y + 0.5)
      goto 1000
c
c  Tensor-producr representation from table in /atlas/
 3000 n=x
      x=xtab(n) + (x-n)*(xtab(n+1) - xtab(n))
      n=y
      y=ytab(n) + (y-n)*(ytab(n+1) - ytab(n))
      goto 1000
c
      end
c_______________________________________________________________________
      subroutine aitoff(lat, lon, x, y)
c$$$$ calls no other routines
c  Maps latitude, longitude into Aitoff's equal-area projection.
c  The sphere is mapped into an ellipse, major semi-axis 2, minor
c  semi-axis 1; the equator is imaged into the major axis, the
c  Greenwhich meridian into the minor axis.  The origin (0, 0), 
c  where the axes cross, may be moved to longitude  phi0  by 
c     call aitoff(lat, lon-phi0, x, y)
c
      real lat, lon
      data degby2/0.008726646/, deg/0.0174532925/
c
      clat=cos(deg*lat)
      half=degby2*(mod(lon+180.0, 360.0) - 180.0)
      R=sqrt(1.0/(abs(1.0 + clat*cos(half)) + 1.0e-15))
      x=2.0*R*clat*sin(half)
      y=R*sin(deg*lat)
      return
      end
c__________________________________________________________________
      subroutine tensor
c$$$$ calls getchr,getone
c  Read spacing file and set up table
      common /atlas/ map,mtab,ntab,xtab(201),ytab(201)
      common /trace/ level,em,en,xfac,yfac
      common /inout/ inp,iout,inf,info
      character *80 space
c
c  Choose a mapping function
      call getone('mapping', amap, nap)
      if (nap .eq. 1) map=amap
c
c  See if tensor spacing is specified
      call getchr('tensor', space, ntens)
c  No tensor spacing mentioned
      if (ntens .lt. 0) then
        if (map .eq. 3 .and. (ntab.ne.en .or. mtab.ne.em)) then
          write(iout,'(a)') 
     $    '>>> Tensor spacing and array size are inconsistent:',
     $    ' Map drawn with even spacing'
          map=1
        endif
c  Read from file if requested.
c  Read list of x spacings first, then y spacings.
      elseif (ntens .eq. 0) then
        write(iout,'(a)') '>>> You must state a filename in the command'
      elseif (ntens .ge. 1) then
c  Open a new file 
        open (unit=8, file=space,err=5000)
        mtab=em
        xtab(1)=0.0
        read (8,*, err=5010) (xtab(j),j=2, mtab)
        ntab=en
        ytab(1)=0.0
        read (8,*, err=5010) (ytab(j),j=2, ntab)
        map=3
        close (unit=8)
c  Sum increment and construct stored table
        do 1100 j=2, mtab
          xtab(j)=xtab(j) + xtab(j-1)
 1100   continue
        do 1150 j=1, mtab
          xtab(j)=(em-1.0)*xtab(j)/xtab(mtab) + 1.0
 1150   continue
c   Do the same for y
        do 1200 j=2, ntab
          ytab(j)=ytab(j) + ytab(j-1)
 1200   continue
        do 1250 j=1, ntab
          ytab(j)=(en-1.0)*ytab(j)/ytab(ntab) + 1.0
 1250   continue
      endif
      if (map .ne. 1) write(iout,'(/a,i3)')
     $' Color map is drawn under mapping ',map
        x=s*sin(deg*lon)
        x=s*sin(deg*lon)
      return
c
c  Error returns
 5000 write(iout,'(a,a)') '>>> Unable to open file ',space
      return
c
 5010 write(iout,'(a,a)') '>>> Read error in file ', space
      return
      end
c__________________________________________________________________
* ====================================== Level-line output handler   END
*=======================================================================
*=======================================================================
* Contour line generating algorithm BEGIN===============================
*
      subroutine glevel(mdim, m, n, f, ds, zlevel)
c$$$$ calls circ,dotted,draw1,draw2,halt,parab
c
c  Principal routine for contouring rectangular arrays of real data.
c  Algorithm by  Dr David P. Anderson,  modified by R. L. Parker (1984).
c
c  Arguments
c   mdim   1st dimension of  f in caller
c   m      number of rows of data in array  f  
c   n      number of columns
c   f      2-dimensional array of values to be contoured
c   ds     step between points on contour in cell units
c   zlevel contour level traced out in this call
c
c  Conventions
c  The standard plotting convention is that  x  increases with
c  i,  the row index of  f(i,j)  and  y  increases with   j.
c  The point (0, 0) with respect to current plot origin
c  corresponds to the matrix element  f(1,1).
c
c  Notes
c  The system calls  dumpit  which has the responsibility of
c  disposing of a vector of points along each contour.  This may
c  mean plotting the points or saving them in an array for later use.
c
c  common /inout/ controls input and output.
c  inp,iout  the input and output unit numbers of the system.
c            Actually glevel nevers uses  inp.
c
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      dimension f(mdim,*)
      common /hlevel/ value
      common /inout/ inp,iout,inf,info
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
c
      integer off(2,3,2),dir
      real c1(2),c2(2),bx(3),by(3),p1(2),p2(2)
      real ang1(2),ang2(2),ang3(2),ang4(2),ang5(2),ang6(2)
      logical ifcase(3),closed
      integer xoff(3,2,2),yoff(3,2,2),koff(3,2,2),doff(3,2,2),ibox(6)
      data xoff/0,0,1,0,1,0, 0, 0, 1,-1,-1,-1/
      data yoff/0,1,0,1,0,0,-1,-1,-1, 0, 0, 1/
      data koff/2,1,2,1,2,1, 2, 1, 2, 1, 2, 1/
      data doff/2,1,1,1,1,2, 2, 2, 1, 2, 2, 1/
      data off/-1,0,1,0,2,0,0,-1,0,1,0,2/
      data ibox/0,0,1,1,0,0/
c
c  Catch various errors
c
      if (m.gt.maxpts .or. n.gt.maxpts) call
     $ halt ('Array dimensions too large - increase parameter  MAXPTS')
c
c  Load  xvals, yvals  with coordinates in inches if dx, dy not zero.
c
      do 231 i=1, m
        xvals(i)=i-1 
 231  continue
      do 232 j=1, n
        yvals(j)=j-1
 232  continue
      smooth=1.0/ds
c
c
      bound(1)=xvals(1)
      bound(2)=xvals(m)
      bound(3)=yvals(1)
      bound(4)=yvals(n)
      eps2=1e-4*max(bound(4)-bound(3), bound(2)-bound(1))**2
c
c
c
c  Find largest, smallest function values to aid user
c
      big=f(1,1)
      small=big
      do 1000 j=1, n
        do 1001 i=1, m
          big=max(big, f(i,j))
          small=min(small, f(i,j))
1001    continue
1000  continue
      range=big-small
c  Trace the contour level
c
        val=zlevel
        value=val
c
c  Make sure no grid points have exact contour values
c
      eps=range*1e-4
      if (eps .eq. 0.0) return
      do 1005 j=1, n
        do 1006 i=1, m
            if (abs(f(i,j)-zlevel) .lt. eps) then
              f(i,j)=zlevel+eps
            end if
1006    continue
1005  continue
c
c
c  Find the points where contour intersects grid lines
c
        do 1009 j=1, n
          do 1010 i=1, m
            a=f(i,j)
            do 1011 k=1, 2
              i2=i+off(1,2,k)
              j2=j+off(2,2,k)
c
c  Make sure segment isn't off the grid
c
              if (i2.le.m.and.j2.le.n) then
                b=f(i2,j2)
                if (a.lt.val.and.b.gt.val.or.b.lt.val.and.a.gt.val)then
c
c  Here if contour crosses this segment - set flag and find point
c
                  flag(k,i,j)=.true.
                  i1=i+off(1,1,k)
                  j1=j+off(2,1,k)
                  i3=i+off(1,3,k)
                  j3=j+off(2,3,k)
c
c  If segment is on edge of grid (pointing toward edge)
c  use single-parabola approximation
c
                  if (i1.le.0.or.j1.le.0) then
                    c=1.-parab(f(i3,j3),f(i2,j2),f(i,j),val)
                    point(k,i,j)=c
                  else if (i3.gt.m.or.j3.gt.n) then
                    c=parab(f(i1,j1),f(i,j),f(i2,j2),val)
                    point(k,i,j)=c
                  else
c
c  Otherwise use double-parabola approximation
c
                    c=parab(f(i1,j1),f(i,j),f(i2,j2),val)
                    d=1.-parab(f(i3,j3),f(i2,j2),f(i,j),val)
                    point(k,i,j)=(c+d)/2.
                  end if
                else
                  flag(k,i,j)=.false.
                end if
              else
                flag(k,i,j)=.false.
              end if
1011        continue
1010      continue
1009    continue
c
c  All points found -- now look for components
c
1012    continue
c
c  The variables in this part are
c  ix, iy           indices of start of current edge
c  ik               direction of edge, 1=x, 2=y
c  dir              direction out of edge, 1=up/right, 2=left/down
c  closed           true if component is a loop
c  ix0,iy0          if closed component, starting point
c
c  Search for a point on border to start from
c
          ik=1
          closed=.false.
          do 1013 ix=1, m-1
            if (flag(1,ix,1)) then
              iy=1
              dir=1
              goto 100
            else if (flag(1,ix,n)) then
              iy=n
              dir=2
              goto 100
            end if
1013      continue
          ik=2
          do 1014 iy=1, n-1
            if (flag(2,1,iy)) then
              ix=1
              dir=1
              goto 100
            else if (flag(2,m,iy)) then
              ix=m
              dir=2
              goto 100
            end if
1014      continue
c
c  If none, search for point in middle
c
          do 1015 iy=1, n
            do 1016 ix=1, m
              do 1017 ik=1, 2
                if (flag(ik,ix,iy)) then
                  dir=1
                  closed=.true.
                  ix0=ix
                  iy0=iy
                  ik0=ik
                  goto 100
                end if
1017          continue
1016        continue
1015      continue
c
c  If can't find a starting point, we're done with this contour value
c
          goto 1018
c
c  Here when found starting point of a component
c  compute its xy coordinates
c
100       continue
          ax=xvals(ix)
          ay=yvals(iy)
          if (ik.eq.1) then
            ax=ax+point(1,ix,iy)*(xvals(ix+1)-xvals(ix))
          else
            ay=ay+point(2,ix,iy)*(yvals(iy+1)-yvals(iy))
          end if
c
c  Start a list (in x, y) of the points on the component
c
          x(1)=ax
          y(1)=ay
          npts=1
          if (.not.closed)flag(ik,ix,iy)=.false.
c
c  Loop for points in this component
c
1019      continue
c
c  From the current edge, there are three possible edges to go to.
c  See which of these edges are on the grid and contain a point.
c
            do 1021 icase=1, 3
              ifcase(icase)=.false.
              jx=ix+xoff(icase,ik,dir)
              jy=iy+yoff(icase,ik,dir)
              jk=koff(icase,ik,dir)
              if (jx.gt.0.and.jy.gt.0) then
c
c  Note flag is false for nonexistent edges
c
                if (flag(jk,jx,jy)) then
                  ifcase(icase)=.true.
                  bx(icase)=xvals(jx)
                  by(icase)=yvals(jy)
                  if (jk.eq.1) then
                    bx(icase)=bx(icase)+point(1,jx,jy)
     +                              *(xvals(jx+1)-xvals(jx))
                  else
                    by(icase)=by(icase)+point(2,jx,jy)
     +                              *(yvals(jy+1)-yvals(jy))
                  end if
                end if
              end if
1021        continue
c
c  See if there wasn't a point where one was expected
c  If this happens there is a bug in the program.  Report it to d.p.a.
c
          if (.not.(ifcase(1).or.ifcase(2).or.ifcase(3))) then
            print *,' Glevel returning prematurely!  Level=',zlevel
            return
          endif
*    $      call halt('Unexpected error line 324 of flevel')
c  If any choice, go across the square
c
            if (ifcase(1).and.ifcase(3)) then
              dist1=(ax-bx(1))**2 + (ay-by(1))**2
              dist3=(ax-bx(3))**2 + (ay-by(3))**2
              if (dist1.lt.dist3) then
                ibest=1
              else
                ibest=3
              end if
            else if (ifcase(1)) then
              ibest=1
            else if (ifcase(3)) then
              ibest=3
            else
              ibest=2
            end if
c
c  Update the coords, etc.
c
            ix=ix+xoff(ibest,ik,dir)
            iy=iy+yoff(ibest,ik,dir)
            dir=doff(ibest,ik,dir)
            ik=koff(ibest,ik,dir)
c
c  Add point to the list
c
            ax=bx(ibest)
            ay=by(ibest)
            npts=npts+1
c
c  Check for array overflow
c
            if (npts.gt.maxcmp)
     $      call halt('Out of room - raise parmeter  maxcmp')
            x(npts)=ax
            y(npts)=ay
c
c  Remove the point from grid so you don't use it again
c
            flag(ik,ix,iy)=.false.
c
c  Check for termination of component
c
            if (closed) then
              if (ix.eq.ix0.and.iy.eq.iy0.and.ik.eq.ik0) then
                npts=npts-1
                goto 1020
              end if
            else
              if (ix.eq.1.and.ik.eq.2.or.
     +        ix.eq.m.and.ik.eq.2.or.
     +        iy.eq.1.and.ik.eq.1.or.
     +        iy.eq.n.and.ik.eq.1) then
                goto 1020
              end if
            end if
            goto 1019
1020      continue
c
c  Here when finished finding points in component.
c  Points are in arrays x,y.  "closed" tells component type.
c
          if (.not.closed) then
c
c  Here to draw open curve
c
            if (npts.eq.2) then
c
c  Component has only two points -- just draw line segment
c
              p1(1)=x(1)
              p1(2)=y(1)
              p2(1)=x(2)
              p2(2)=y(2)
              call dotted(p1,p2)
            else
c
c  Component has three or more points -- draw nice curves
c
              call circ(1,2,3,c1,rad1,ang1,ang2,ang3)
              call draw1(c1,rad1,ang1,ang2)
              do 1030 i=2, npts-2
                call circ(i,i+1,i+2,c2,rad2,ang4,ang5,ang6)
                call draw2(c1,c2,rad1,rad2,ang2,ang3,ang4,ang5)
                c1(1)=c2(1)
                c1(2)=c2(2)
                rad1=rad2
                ang2(1)=ang5(1)
                ang2(2)=ang5(2)
                ang3(1)=ang6(1)
                ang3(2)=ang6(2)
1030          continue
              call draw1(c1,rad1,ang2,ang3)
            end if
          else
c
c  Here to draw closed curve
c
            call circ(npts,1,2,c1,rad1,ang1,ang2,ang3)
            do 1031 i=1, npts
              j=mod(i,npts)+1
              k=mod(i+1,npts)+1
              call circ(i,j,k,c2,rad2,ang4,ang5,ang6)
              call draw2(c1,c2,rad1,rad2,ang2,ang3,ang4,ang5)
              c1(1)=c2(1)
              c1(2)=c2(2)
              rad1=rad2
              ang2(1)=ang5(1)
              ang2(2)=ang5(2)
              ang3(1)=ang6(1)
              ang3(2)=ang6(2)
1031        continue
          end if
          goto 1012
1018    continue
c
c  Flush the plot buffer.  The coordinates given cannot be on a contour
c
      iline=0
      c1(1)=xvals(1) - 0.1
      c1(2)=c1(1)
      call dotted(c1, c1)
      return
      end
c______________________________________________________________
      subroutine circ(i, j, k, center, radius, ang1, ang2, ang3)
c$$$$ calls no other routines
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      common /inout/ inp,iout,inf,info 
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
c
c  Routine to find the center, radius and angular limits of the
c  circular arc determined by the points with indices i, j, k in the
c  arrays x and y.  If colinear return radius=-1 and put the
c  three points in ang1, ang2 and ang3.
c
      real center(2),ang1(2),ang2(2),ang3(2)
      data pi2/6.283185/
c
c  The formulas here are hard to derive, at least they were for me
c
      a=(x(i)+x(j))/2.
      b=(y(i)+y(j))/2.
      c=y(j)-y(i)
      d=x(i)-x(j)
      e=(x(j)+x(k))/2.
      ff=(y(j)+y(k))/2.
      g=y(k)-y(j)
      h=x(j)-x(k)
      disc=d*g-c*h
c
c  Check for colinearity
c
      if (abs(disc).lt.eps2) then
        radius=-1.
        ang1(1)=x(i)
        ang1(2)=y(i)
        ang2(1)=x(j)
        ang2(2)=y(j)
        ang3(1)=x(k)
        ang3(2)=y(k)
      else
        t=(d*a+ff*c-b*c-d*e)/disc
        center(1)=e+g*t
        center(2)=ff+h*t
        radius=sqrt((center(1)-x(i))**2+(center(2)-y(i))**2)
        a=x(i)-center(1)
        b=y(i)-center(2)
        c=x(j)-center(1)
        d=y(j)-center(2)
        e=x(k)-center(1)
        ff=y(k)-center(2)
        ang1(1)=atan2(b,a)
        ang2(1)=atan2(d,c)
        ang3(1)=atan2(ff,e)
c
c  Make sure angles are in the right order by adding pi*2 to
c  some of them, if needed.
c
        if (ang1(1).lt.ang2(1)) then
          if (ang1(1).lt.ang3(1).and.ang3(1).lt.ang2(1)) then
            ang1(1)=ang1(1)+pi2
          else if (ang3(1).lt.ang1(1)) then
            ang3(1)=ang3(1)+pi2
          end if
        else
          if (ang2(1).lt.ang3(1).and.ang3(1).lt.ang1(1)) then
            ang1(1)=ang1(1)-pi2
          else if (ang3(1).gt.ang1(1)) then
            ang3(1)=ang3(1)-pi2
          end if
        end if
      end if
      return
      end
c______________________________________________________________
      subroutine draw1(center, radius, ang1, ang2)
c$$$$ calls dotted, vmov2
c  Routine to draw a circular arc
c  radius = 0 means draw segments from point ang1 to ang2
c
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      common /inout/ inp,iout,inf,info 
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
      real center(2),radius,ang1(2),ang2(2),p1(2),p2(2)
      if (radius.ge.0) then
        dang=ang2(1)-ang1(1)
        arclng=abs(dang)*radius
        nsteps=arclng*smooth+1
        da=dang/nsteps
        do 1000 i=0, nsteps
          angle=ang1(1)+(i)*da
          p2(1)=radius*cos(angle)+center(1)
          p2(2)=radius*sin(angle)+center(2)
          if (i.ne.0) call dotted(p1,p2)
          call vmov2(p2,p1)
1000    continue
      else
        call dotted(ang1,ang2)
      end if
      return
      end
c______________________________________________________________
      subroutine draw2(cent1, cent2, rad1, rad2, ang1, ang2, ang3, ang4)
c$$$$ calls dotted, vmov2
c  Routine to draw the average of two circular arcs
c
c  cent1 and cent2 are the centers
c  rad1 and rad1 are the radii
c  If either radius is zero it means the arc is really a line
c  segment whose endpoints are in (ang1,ang2) or (ang3,ang4)
c
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      common /inout/ inp,iout,inf,info
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
      real cent1(2),cent2(2),ang1(2),ang2(2),ang3(2),ang4(2)
      real p1(2),p2(2)
c
c  Find angular ranges (or vector)
c
      dang11=ang2(1)-ang1(1)
      dang12=ang2(2)-ang1(2)
      dang21=ang4(1)-ang3(1)
      dang22=ang4(2)-ang3(2)
c
c  Find approximate length of arc or segment
c
      if (rad1.ge.0) then
        arclng=abs(dang11)*rad1
      else
        arclng=sqrt((dang11)**2+(dang12)**2)
      end if
c
c  Compute number of steps based on that
c
      nsteps=arclng*smooth+1
c
c  Loop for points along curve
c
      do 1000 i=0, nsteps
        t=float(i)/nsteps
c
c  Compute point on first arc
c
        if (rad1.ge.0) then
          angle=ang1(1)+t*(dang11)
          r1=cent1(1)+rad1*cos(angle)
          r2=cent1(2)+rad1*sin(angle)
        else
          r1=ang1(1)+t*(dang11)
          r2=ang1(2)+t*(dang12)
        end if
c
c  Compute point on second arc
c
        if (rad2.ge.0) then
          angle=ang3(1)+t*(dang21)
          q1=cent2(1)+rad2*cos(angle)
          q2=cent2(2)+rad2*sin(angle)
        else
          q1=ang3(1)+t*(dang21)
          q2=ang3(2)+t*(dang22)
        end if
c
c  Take weighted average.  Note weighting coefficients.
c
        p2(1)=r1*(1.-t)+q1*t
        p2(2)=r2*(1.-t)+q2*t
        if (i.ne.0) call dotted(p1,p2)
        call vmov2(p2,p1)
1000  continue
      return
      end
c______________________________________________________________
      real function parab(r1, s1, t1, val)
c$$$$ calls no other routines
c  Suppose a quadratic function f has f(-1)=r1, f(0)=s1, and f(1)=t1,
c  with val between s and t.
c  Where between 0 and 1 does the parabola assume the value "val"?
c
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      common /inout/ inp,iout,inf,info
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
      r=r1-val
      s=s1-val
      t=t1-val
      a=(r+t)/2-s
      if (abs(a).lt.eps) then
      parab=s/(s-t)
      return
      end if
      b=(t-r)/2
      c=s
      disc=sqrt(b**2-4*a*c)
      d=(-b+disc)/(2*a)
      if (d.ge.0.and.d.le.1) then
      parab=d
      else
      parab=(-b-disc)/(2*a)
      end if
      return
      end
c______________________________________________________________
      subroutine vmov2(a, b)
c$$$$ calls no other routines
      real a(2),b(2)
c
      b(1)=a(1)
      b(2)=a(2)
      return
      end
c______________________________________________________________
      subroutine mabel(val, len, label)
c$$$$ calls no other routines
c  For a real number  val  assumed to be a decimal fraction rounded to
c  6 significant figures (or fewer), makes an equivalent character
c  string  label  of minimal length  len.
      character*8 form,local*20,label*(*)
      double precision ten, v
      data ten/10.0d00/
c
c  Find the number of significant figures in val
c
      nexp=0.0
      if (val .ne. 0.0) nexp=int(500.01 + log10(abs(val))) - 500
      v=dint(abs(val)/ten**(nexp-5) + 0.5)
      nres=nexp - 5
      do 1100 ipow=0, 4
        if (dmod(dint(v/ten**ipow+ 0.5), ten) .ne. 0.0) goto 1110
        nres=nres + 1
 1100 continue
 1110 nfld=3 + max(nexp, -nres, nexp-nres)
c
c  Build a format for writing the string
c
      ndpt=max(0, -nres)
      write(form, '( 2h(f, i2, 1h., i1, 1h))') nfld,ndpt
      if (ndpt .eq. 0) nfld=nfld - 1
c  If format is screwed up try a g format:
      if (index(form,'*') .ne. 0) form='(g12.4)'
c
c  Construct a character string of minimal length for the label
c
      write(local, form) val
c  Remove leading blanks.
      is=1
      do 1200 i=1, nfld
        if (local(i:i) .eq. ' ') is=1 + is
 1200 continue 
      label=local(is:nfld)
      len=nfld - is + 1
      return
      end
c______________________________________________________________
      subroutine dotted(p1, p2)
c$$$$ calls dumpit
c  Collects a buffer of points to be plotted in the arrays  xx, yy.
c  If a discontinuity is encountered or the buffer is filled, flushes
c  the buffer with routine  dumpit.
c
      parameter (maxpts=998, maxcmp=10*maxpts)
      logical*1 flag
      common /hlevel/ value
      common /inout/ inp,iout,inf,info 
      common /option/ smooth,
     $                xvals(maxpts),yvals(maxpts)
      common /big1/ point(2,maxpts,maxpts) /big2/ flag(2,maxpts,maxpts)
      common /little/ iline,eps,eps2,bound(4),x(maxcmp),y(maxcmp)
      real p1(2),p2(2),xx(maxcmp),yy(maxcmp)
      save xx,yy,nxy,lastln
      data nxy/0/, lastln/-1/
c
c  Advance the buffer count
      nxy=1 + nxy
c
c  Initialize a new buffer
 1000 if (nxy .eq. 1) then
       lastln=iline
       xx(nxy)=p1(1)
       yy(nxy)=p1(2)
       nxy=2
       xx(nxy)=p2(1)
       yy(nxy)=p2(2)
       return
      endif
c
c  Add another point to the buffer.  Only done if this line piece
c  is contiguous with the previous one and if the buffer isn't full
      if ((xx(nxy-1)-p1(1))**2+(yy(nxy-1)-p1(2))**2.lt.1e-6
     $   .and. nxy.le.maxcmp)  then
        xx(nxy)=p2(1)
        yy(nxy)=p2(2)
        return
      endif
c
c  Flush the buffer.  Noncontiguous line piece has been encountered.
      nxy=nxy - 1
      call dumpit(value, nxy, xx, yy)
c  Re-initialize the buffer
      nxy=1
      if (iline .gt. 0) goto 1000
c
c  If  nline is not positive reinitialize buffer
c
      nxy=0
      lastln=-1
      return
      end
c______________________________________________________________
      subroutine halt(messag)
c$$$$ calls no other routines
c  Program prints the message  messag  then stops.
      character*(*) messag
c
      print '(/1x, a)', messag
      stop
      end
c______________________________________________________________
*     blockdata dfault
c  Sets various parameters into common for the user's convenience.
c  Values for standard  input and output defined in graphics BLOCKDATA
c     common /inout/ inp,iout,inf,info
c
*     data inp,iout,inf,info /5,6,7,7/
c
*     end
c______________________________________________________________
* ================================ Contour line generating algorithm END
*=======================================================================
*=======================================================================
* Language unit BEGIN===================================================
*
      subroutine peruse(ihead)
c$$$$ calls quit
c  The command input routine.
c  Reads command lines from the standard input until eof 
c  or the command 'plot' or 'read' is encountered.
c  Saves the lines in the character array input for later
c  parsing by getchr and getval.
c  Prints a list of commands for this group of routines
      parameter (inmx=400)
      character *80 input(inmx),line
      common /dicta/ input
      common /ndict/ iecho,nin,istate(inmx)
      common /inout/ inp,iout,inf,info
c
c
      if (ihead .ne. 0) write(iout,'(a)') ' ',
     $' Enter commands for data input and contouring '
c
      do 1500 l=nin+1, inmx
        read(inp,'(80a)', end=2500) line
        if (line(1:1) .ne. ' ') then
          nin=nin + 1
          input(nin)=line
          istate(nin)=0
        endif
        if (line(1:4) .eq. 'hist') then
          nin=nin - 1
          write(iout,'(/a/(i3,a,a75))') 'Command history to date',
     $  (k,': ',input(k)(1:74), k=1, nin)
        endif
        if (line(1:4) .eq. 'plot') goto 2000
        if (line(1:4) .eq. 'read') goto 2000
        if (line(1:4).eq.'stop' .or. line(1:4).eq.'quit') call quit
 1500 continue
c
 2000 return
c
 2500 call quit
      end
c______________________________________________________________________
      subroutine getval(code, values, nwant, nfound)
c$$$$ calls no other routines
c
c  Seek a fresh instance of the command  code  in the input store.  
c  Previously discovered instances are skipped.
c  If  code  is not in the store, set nfound=-99.
c  If the command is present, nfound is set  nfound >= 0.
c  Then the remainder of the line is analysed, looking for an array 
c  of up to  nwant  numbers.   On return the numbers are put into  the
c  array  values, and  nfound  is set to the number of items found which
c  will not be more than  nwant  but may be zero.
c  If an error is discovered  nfound=-n,  where  n  is the number of 
c  numbers properly decoded. 
c
      parameter (inmx=400)
      character *80 input(inmx),line
      common /dicta/ input
      common /ndict/ iecho,nin,istate(inmx)
      common /inout/ inp,iout,inf,info
      dimension values(*)
      character local*40, code*4, char*80
c
ce
      do 1010 lin=nin, 1, -1
        line=input(lin)
        if (code .eq. line(1:4) .and. istate(lin) .eq. 0) then
          if (iecho .ge. 1) write(iout,'(2a)')'>>> ',line
          istate(lin)=istate(lin) + 1
          nb=index(line, ' ')+1
          char=line(nb:80)
          kn=80 - nb + 1
          goto 1020
        endif
 1010 continue
c  code word not found
      nfound=-99
      return
c
 1020 continue
      k1=1
c  Up to  nwant  numbers are sought.
      do 1800 nval=1, nwant
        do 1100 k=k1, kn
          if (char(k:k) .ne. ' ') goto 1200
 1100   continue
        nfound=nval-1
        return
 1200   do 1300 l=k, kn
          if (char(l:l).eq. ',' .or. char(l:l).eq. ' ') goto 1500
 1300   continue
c  Augment unpredictable error trapping of some compilers e.g. Sun
 1500   if (index('	Ee+-.0123456789', char(k:k)) .eq. 0) goto 2000
        k2=l+1
        local=char(k:l-1)
        read (local, '(f40.0)', err=2000) values(nval)
 1800 k1=k2
      nval=1 - nwant
 1900 nfound=1 - nval
      return
c
 2000 write(iout, '(a)')' ',
     $'***** Unreadable numbers in this input line:',line
      goto 1900
      end
c______________________________________________________________
      subroutine getchr(code, char, nfound)
c$$$$ calls no other routines
c  Seeks a fresh instance of the command  code  in the input store.
c  Previously analysed instances are skipped.
c  If  code  is not present returns  nfound=-99.
c  If the command is present returns the rest of the line, beginning at
c  the first nonblank in  char  and sets nfound=1, unless the line is
c  entirely blank; then  nfound=0  and  char is left undisturbed.
c
      parameter (inmx=400)
      character *80 input(inmx),blank, line,code*4, char*(*)
      common /dicta/ input
      common /ndict/ iecho,nin,istate(inmx)
      common /inout/ inp,iout,inf,info
      data blank/' '/
ce
      do 1010 lin=nin, 1, -1
        line=input(lin)
        if (code .eq. line(1:4) .and. istate(lin) .eq. 0) then
          if (iecho .ge. 1) write(iout,'(2a)')'>>> ',line
          istate(lin)=istate(lin) + 1
          goto 1020
        endif
 1010 continue
c  code word not found
      nfound=-99
      return
c
 1020 continue
      nb=index(line, ' ')+1
      do 1200 k=nb, 80
        if (line(k:k) .ne. ' ') then
          char=line(k:80)
          nfound=1
          return
        endif
 1200 continue
c
c  Blank field after code word
      nfound=0
      return
      end
c______________________________________________________________
      subroutine getone(code, value, nfound)
c$$$$ calls getval
c
c  Evaluates a single number from the input store /dicta/ associated
c  with the keyword code.  The answer is returned in  value.
c  nfound  may be 1 if a number is read, 0 if the field after
c  code is blank, -99 if code is absent.
c  
      dimension values(1)
      character code*4
c
      call getval(code, values, 1, nfound)
      if (nfound .eq. 1) value=values(1)
      return
      end
c______________________________________________________________
*===================================================== Language unit END
c=======================================================================
*=======================================================================
* Array input routines BEGIN============================================
*
      subroutine getmat(m, n, a)
c$$$$ calls getchr,getval,matrab,matraf,group
c  Routine for reading matrices and re-orienting them on the page.
c  When orient command is invoked defines plotted array as follows:
c  N normal - as in a numerical listing; T transposed array;
c  R 90-deg clockwise turn; RR 2 90-deg turns, etc;
c  V  reflect array in veryical line; H reflect in horizontal line.
c
c  ms, ns  dimensions of array as it was written.
c  klock   number of clockwise quarter-turns.
c  m, n    array dimensions of matrix as actually used in program.
c
      parameter (maxa = 907 000)
      common /inout/ inp,iout,inf,info
      character*75  format,file,ops
      dimension a(*), val(37)
      save format,file,skip,kode1,kode2
      data format(1:4)/'    '/, file(1:1)/' '/, skip/0.0/
      data kode1/0/
c
c  Look for orientation command in list
      call getchr('orie', ops, nf)
      if (nf .ge. 1) then
        call group(ops, kode1,kode2)
      endif
c
c  Look for the read statement in the command list
      val(3)=0
      call getval('read', val, 3, nfound)
      if (nfound .eq. -99) then
        if (m .gt. 0) return
        write(iout, '(a)')' ',
     $  '>>> No read statement in list. Provide one'
        m=0
        return
      elseif (nfound .le. 1) then
        write(iout, '(a)')' ',
     $  '>>> read must be followed by 2 or 3 numbers'
        m=0
        return
      else
        ms=val(1)
        ns=val(2)
        klock=val(3)
c  Revise read specs if orient command has been used
        if (kode1 .ne. 0) then
          ms=sign(ms, kode1)
          ns=abs(ns)
          klock=kode2
        endif
      endif
c
c  Impossible array dimensions trapped
      if (abs(ms).le.1.or.abs(ns).le.1.or.abs(ms*ns).gt.maxa) then
        write(iout, '(/a,2i5/a)')
     $  '>>> Improper array dimensions',ms,ns,'Array cannot be accepted'
        if (abs(ms*ns).gt.maxa) write(iout,'(a,i8)')
     $  '>>> Total array size exceeds maximum permitted, ie ',maxa
        m=0
        return
      endif
c
c  Ascertain file name from file command
      call getchr('file', file, nf)
      if (file(1:1) .eq. ' ') then
        write(iout,'(a)')' ',
     $  '>>> No file name has been provided for data'
        m=0
        return
      endif
c  Ascertain format if specified
      call getchr('format', format, nf)
c
c  Open the file
      if (file .eq. '*') then
        inf=inp
      else
        inf=8
        if (format(1:1) .eq. ' ') then
          open (unit=8, file=file, status='OLD', err=2000)
          call getone('skip', skip, iskip)
          nskip=skip
          do 1100 j=1, nskip
            read(8,*)
 1100     continue
        endif
        if (format(1:1) .eq. 'b') open (unit=8, file=file,
     $     status='OLD', err=2000, form='UNFORMATTED')
      endif
c
c  Determine the array dimensions as they really are.
c
      if (mod(klock,2) .eq. 0) then
        m=iabs(ms)
        n=iabs(ns)
      else
        m=iabs(ns)
        n=iabs(ms)
      endif
c
c  Code the sign configuration into a single integer
c
      jsign=(5 - isign(2,ns) - isign(1,ms))/2
c
c  Now read the thing in,  either formatted or binary.
c  Notice room for border of 1 cell all round.
c
      if (format(1:1).ne.'b') call matraf(m+2,m,n, a(m+4), klock, jsign)
      if (format(1:1).eq.'b') call matrab(m+2,m,n, a(m+4), klock, jsign)
      if (inf .ne. inp) close (unit=8)
c
      return
c
c  Can't open the file for some reason.
 2000 write(iout,'(/a)')'>>> Nonexistent file or read permission denied'
      m=0
      return
      end
c______________________________________________________________
      subroutine matrab(mdim, m, n, a, klack, jsign)
c$$$$ calls no other routines
c  Routine actually to read binary diskfile.
c  It is assumed the file was written by rows with a statement like
c        do 1000 i=1, m
c   1000 write(iunit) (a(i,j), j=1, n)
c  in an ftn77  compiled program. 
c
      common /inout/ inp,iout,inf,info
      dimension a(mdim,*)
      dimension         lookup(4,4)
      data lookup /1,2,3,4,5,6,7,8,   
     $             4,3,2,1,8,7,6,5/
c
c  Transform the number of clockwise rotations to one of  0,1,2,3
c
      klick=mod(mod(klack,4) + 4, 4)
c
c  All possible orientations reduce to one of the 8 below.  lookup
c  has this coded into it.
c
      igo=lookup(jsign, klick+1)
      goto (1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080), igo
c
c  No transformations.  Read  a  as written
 1010 do 1015 i=1, m
 1015 read (inf, end=2000) (a(i,j), j=1,n)
      return
c
c  v - reflect in vertical plane
 1020 do 1025 i=m,1,-1
 1025 read (inf, end=2000) (a(i,j), j=1,n)
      return
c
c  h - reflect in horizontal plane
 1030 do 1035 i=1,m
 1035 read (inf, end=2000) (a(i,j), j=n,1,-1)
      return
c
c  vh = r**2  - reflect in v and h =  2 clockwise 90 deg turns
 1040 do 1045 i=m,1,-1
 1045 read (inf, end=2000) (a(i,j), j=n,1,-1)
      return
c
c  r - 1 clockwise 90 deg turn
 1050 do 1055 j=n,1,-1
 1055 read (inf, end=2000) (a(i,j), i=1,m)
      return
c
c  rv - v reflection followed by r
 1060 do 1065 j=n,1,-1
 1065 read (inf, end=2000) (a(i,j), i=m,1,-1)
      return
c
c  rh - h reflection followed by r = transpose of a
 1070 do 1075 j=1,n
 1075 read (inf, end=2000) (a(i,j), i=1,m)
      return
c  r**3=r**-1 - 3 clockwise 90 deg turns = one anticlockwise
 1080 do 1085 j=1,n
 1085 read (inf, end=2000) (a(i,j), i=m,1,-1)
      return
c
c  Error section.  Improper dimensions have been supplied
c
 2000 write(iout,'(a)') ' ','>>> Unexpected endfile encountered',
     $'Improper array size has been given -  File rewound'
      m=0
      rewind inf
      return
      end
c______________________________________________________________
      subroutine matraf(mdim, m, n, a, klack, jsign)
c$$$$ calls no other routines
c  Routine actually to read formatted diskfile with * format
c  it is assumed the file was written by rows with a statement like
c     write(iunit, format) ((a(i,j), j=1, n), i=1, m)
c
      common /inout/ inp,iout,inf,info
      dimension a(mdim,*)
      dimension         lookup(4,4)
      data lookup /1,2,3,4,5,6,7,8,   
     $             4,3,2,1,8,7,6,5/
c
c  Transform the number of clockwise rotations to one of  0,1,2,3
c
      klick=mod(mod(klack,4) + 4, 4)
c
c  All possible orientations reduce to one of the 8 below.  lookup
c  has this coded into it.
c
      igo=lookup(jsign, klick+1)
c
      goto (1010, 1020, 1030, 1040, 1050, 1060, 1070, 1080), igo
c
c  No transformations.  Read  a  as written
 1010 read (inf,*, err=2010,end=2000) ((a(i,j), j=1,n), i=1, m)
      return
c
c  v - reflect in vertical plane
 1020 read (inf,*, err=2010,end=2000) ((a(i,j), j=1,n), i=m,1,-1)
      return
c
c  h - reflect in horizontal plane
 1030 read (inf,*, err=2010,end=2000) ((a(i,j), j=n,1,-1), i=1,m)
      return
c
c  vh = r**2  - reflect in v and h =  2 clockwise 90 deg turns
 1040 read (inf,*, err=2010,end=2000) ((a(i,j), j=n,1,-1), i=m,1,-1)
      return
c
c  r - 1 clockwise 90 deg turn
 1050 read (inf,*, err=2010,end=2000) ((a(i,j), i=1,m), j=n,1,-1)
      return
c
c  rv - v reflection followed by r
 1060 read (inf,*, err=2010,end=2000) ((a(i,j), i=m,1,-1), j=n,1,-1)
      return
c
c  rh - h reflection followed by r = transpose of a
 1070 read (inf,*, err=2010,end=2000) ((a(i,j), i=1,m), j=1,n)
      return
c  r**3=r**-1 - 3 clockwise 90 deg turns = one anticlockwise
 1080 read (inf,*, err=2010,end=2000) ((a(i,j), i=m,1,-1), j=1,n)
      return
c
c  Error section.  Improper dimensions have been supplied
c
 2000 write(iout,'(a)') ' ','>>> Unexpected endfile encountered',
     $'Improper array size has been given -  File rewound'
      m=0
      if (inf.ne.inp) rewind inf
      return
c
 2010 write(iout,'(a)') ' ','>>> Error while reading array data',
     $'File rewound'
      m=0
      if (inf.ne.inp) rewind inf
      return
      end
c______________________________________________________________
      subroutine assess(fmin, fmax, step, nlev, zlevs)
c$$$$ calls no other routines
c  Finds relatively nice subdivisions on interval (fmin, fmax)
c  returning the number of divisions in  nlev  and the array of
c  values in zlevs.
c  If  step > 0 uses this interval to construct the subdivisions.
      dimension zlevs(*),divs(7)
      data fac/3.5/, mlines/11/
      data divs /.05d0,.1d0,.2d0,.25d0,.5d0,1.0d0,2.0d0/
c
c  Use the numbers provided to build a set of level lines
      if (step .gt. 0.0) then
        k=0
        do 1100 x=fmin, fmax+0.1*step, step
          k=k + 1
          zlevs(k)=x
          if (abs(x) .lt. 1e-4*step) zlevs(k)=0.0
 1100   continue
        nlev=k
        return
      endif
c
c  Make up a nice covering interval.
      f1=fmin
      f2=fmax
      if (f1 .eq. f2) f2=1.0 + 1.1*f1
      plus=1000.0 + log10(f2 - f1)
      da=10.0**mod(plus, 1.0)
      do 2100 i=1, 7
        ii=i
        if (mlines .ge. da/divs(ii)) go to 2110
 2100 continue
 2110 units=divs(ii)*10.0**(int(plus)-1000)
      uns=aint(f1/units - 0.01)
c  Generates levels
      nlines=0
      do 2200 i=1, mlines
         v=units*(uns + i - 2)
         if (v .ge. fmin-units .and. v .le. fmax) then
           nlines=nlines + 1
           zlevs(nlines)=v
         endif
 2200 continue
      zlevs(nlines+1)=zlevs(1)
      nlev=nlines
c
      return
      end
c______________________________________________________________
      subroutine group(string, k1,k2)
c$$$$ calls no other routines
c  Given a string representing repeated application on an array of
c  the actions:
c    R rotate 90 deg clockwise; V reflect in a verical plane
c    H reflect in a horizontal plane; T transpose,
c  finds an integer representing one of the states of the array
c    1=unaltered; 2=V; 3=H; 4=RR; 5=R; 6=T; 7=RH; 8=RRR.
c
c  This in turn is decoded into [m n r] form in k1, k2.
c
c  The order of operations is as one reads - thus RTV means
c  first rotate array once, then transpose the result, then reflect the
c  result in a vertical plane.
      dimension multab(8,8), map(8,2)
      character *(*) string
c  This is the group multiplication table
      data ((multab(i,j),j=1,8),i=1,8)/
     $1,2,3,4,5,6,7,8,  2,1,4,3,7,8,5,6,  3,4,1,2,6,5,8,7,
     $4,3,2,1,8,7,6,5,  5,6,7,8,4,3,2,1,  6,5,8,7,2,1,4,3,
     $7,8,5,6,3,4,1,2,  8,7,6,5,1,2,3,4/
      data ((map(i,j),j=1,2),i=1,8)/
     $1,1, -1,1, -1,-1, 1,-1, 1,2, -1,2, -1,0, 1,0/
c
      igroup=1
      l=len(string)
      do 1500 i=1, l
        k=index('.VH.RT',string(i:i))
        if(k .ge. 2) igroup=multab(igroup,k)
 1500 continue
c
c  Map orientation into [m, n, r] instructions
      k1=map(igroup,1)
      k2=map(igroup,2)
      return
      end
c_________________________________________________________________
*============================================== Array input routines END
*=======================================================================
*=======================================================================
*  Map generator and page manager BEGIN ================================
*
      subroutine major(mdim, m, n, a)
c$$$$ calls assess,bar,border,getchr,getval,letter,minmax,paint,sort,
c$$$$ also calls table,xyline
c
c  The major routine for producing color map of the array  a.
c  m, n  are the internal array dimensions.
c  mdim  is the row dimension as  a  is stored (=m+2)
c
c  The routine positions the plot on the paper, opens the plotfile,
c  invokes the painting routine and positions the origin, puts
c  the color key at the right and writes the plot label.
c
c  Postscript prolog written here also.
c
      parameter (levmx=50)
      dimension a(mdim, *), zlevs(levmx), xyorg(2),xynew(2)
      common /xtreme/ bord,amin,amax,anull(2),alim(3),colim(2)
      parameter (lpmx=250000, knmx=300000)
      integer*2 kxy
      common /arcs/ loops,istart(lpmx),area(lpmx),lev(lpmx),kxy(2,knmx)
      common /trace/ level,em,en,xfac,yfac
      common /noir/ scutum,kolors,art(4,levmx),kart(levmx),loutln(levmx)
      common /pallet/ many,npal(10),hue(28,10),sat(28,10),bri(28,10)
      common /inout/ inp,iout,inf,info
      common /local/ color(1),black(2)
      common /outfil/ output
c
      dimension hw(3), weight(1)
      character*80 output, label, onoff*2,boff*2
      save kase, hw, xyorg, xynew, weight
      data kase/0/,  hw/2*0, 0.08333/, nlev/0/
      data xyorg/0,1000/, xynew/0,0/
      data onoff/'of'/, boff/'of'/, weight/10/
c
c  No array has been provided. Abandon ship
c
      if (m .eq. 0) then
         write(iout, '(/a)')'>>> Nothing to plot - read an array'
         return
      endif
c
c  Get a substitute color table for palette 1 if desired
      call table
c
      kase=1 + kase
      loops=0
      istart(1)=1
c  First time through - open plotfile and set landscape/portrait
      if (kase .eq. 1) then
        call getchr('landscape',  label, land)
        output='mypost'
        call getchr('output', output, nf)
        open(unit=9, file=output)
        write(9,'(a)') '%!','initmatrix','0.072 0.072 scale'
        if (land .ge. 0) write(9,'(a)')
     $  '4250 6750 translate -90 rotate -4250 -4250 translate'
        write(9,'(a)') '200 200 translate',
     $  '/m {newpath moveto} def','/r {rlineto}def'
      endif
c
c   Determine extremes of function to be plotted; if interval has
c   been set explicitly retain the values.
      call minmax(m+2, m ,n, a(2,2), amin, amax)
      call getval('interval', alim,  3, nlim)
      step=0
      if (nlim .ge. 2) kolors=0
      if (alim(1) .lt. alim(2)) then
        colim(1)=alim(1)
        colim(2)=alim(2)
        if (nlim .eq. 3) step=alim(3)*
     $  (0.5 + sign(0.5, alim(3) - (alim(2)-alim(1))/(levmx-1)))
      else
c  No interval set - default to data extremes
        colim(1)=amin
        colim(2)=amax
      endif
      if (info .ge. 1) write(iout,'(/(a,1p,2g12.4))')
     $' Array values fall within   ',amin,amax,
     $' Contouring performed within',colim,  ' '
c
c
c  Painstaking representation of color scheme - takes precedence over
c  palette or levels command
      call getval('above', art(1,1), 4, nart)
c
c  Transitions specified by "above" command
      if (nart .gt. 0) then
        zlevs(1)=art(1,1)
        do 1100 k=2, levmx
          call getval('above', art(1,k), 4, nart)
          zlevs(k)=art(1,k)
          if (nart .lt. 0) goto 1110
 1100   continue
        write (iout,'(a)') '>>> Too many levels requested. ',
     $  'If necessary increase parameter LEVMX and recompile'
        k=levmx + 1
 1110   kolors=max(2, k-1)
        call sort(kolors, zlevs, kart)
c
c  Transitions NOT specified by "above" command
      else
c  
c  Determine transition levels, either from input or from array itself
        call getval('levels', zlevs, levmx, nf)
c  There is NO  "levels" command
        if (nf .le. 0) then
          if (kolors .eq. 0) then
            call assess(colim(1), colim(2), step, nlev, zlevs)
          else
            nlev=kolors
          endif
c  There IS a "levels" command
        else
c  Get any further lines of levels
          do 1500 k=1,4
            call getval('levels', zlevs(nf+1), levmx-nf, kf)
            if (kf .le. 0) goto 1510
            nf=nf + kf
 1500     continue
 1510     nlev=nf
          if (nlev .eq. 1) then
            zlevs(2)=zlevs(1) - max(0.5*abs(zlevs(1)), 1.0)
            nlev=2
          endif
c  Revise color limits if levels have been set explicitly
          call minmax(nlev, nlev, 1, zlevs, colim(1), colim(2))
          call sort(nlev, zlevs, kart)
        endif
c  Transition levels have been set or inherited from previous plot
c
c 
c  Choose colors from a standard palette 
        call getval('palette', color, 3, nblck)
c  Check alternative spelling "pallet"
        if (nblck .lt. 0) call getval('pallet', color, 3, nblck)
        if (nblck.gt.0 .or. kolors.eq.0) then
          kolors=nlev
          match=color(1)
          if (info.ge.1) write(iout,'(a,i3)')
     $    ' Colors drawn from standard palette ',match
c  If this is a greytone (match=0) get shade parameters
          if (match .le. 0) then
            bfact=sign(1.0, black(1))/((colim(2)-colim(1)) + 1.0e-8)
            offst=0.5 - sign(0.5, black(1))
            ablack=abs(black(1))
            do 1600 k=1, nlev
              art(1,k)=zlevs(k)
              art(3,k)=0.0
              art(4,k)=1.0-ablack*
     $          abs(offst + bfact*(zlevs(k)-colim(1)))**black(2)
 1600       continue
          else
c  Canned palette hsb values obtained from common /artist/
c  If number of colors required (nlev) .lt. number available (ncav),
c  pick a color from palette, otherwise interpolate.
            mtch=min(many, match)
            ncav=npal(mtch)
            beta=(ncav -1 )/(colim(2) - colim(1))
            do 1700 k=1, nlev
              art(1,k)=zlevs(k)
              alf=1.0 + beta*(zlevs(k) - colim(1))
              i=alf
              gamma=0.0
              if (nlev .gt. ncav) then 
                gamma=alf-i
                art(2,k)=(1.0-gamma)*hue(i,mtch) + gamma*hue(i+1,mtch)
                art(3,k)=(1.0-gamma)*sat(i,mtch) + gamma*sat(i+1,mtch)
                art(4,k)=(1.0-gamma)*bri(i,mtch) + gamma*bri(i+1,mtch)
              else
                kin=1 + nint((k-1)*(ncav-2.0)/(nlev-1.0))
                if (nlev .eq. ncav) kin=k
                art(2,k)=hue(kin+1,mtch)
                art(3,k)=sat(kin+1,mtch)
                art(4,k)=bri(kin+1,mtch)
              endif
 1700       continue
          endif
          call sort(nlev, zlevs, kart)
        endif
        kolors=nlev
      endif
c
      if (info .ge. 1) then
        write(iout,'(a)')' ',
     $'  These levels and color codes have been set',
     $'     level          hue   staturation brightness'
        do 1800 kl=1, kolors
          k=kart(kl)
          write(iout,'(i2,g12.4,3f10.3)') kl, (art(j,k),j=1,4)
 1800   continue
      endif
c
c
c  Fill artificial border with a small value
      bord=amin - 0.1*(amax - amin)
      do 2100 i=1, m+2
        a(i,1)=  bord
        a(i,n+2)=bord
 2100 continue
      do 2200 j=1, n+2
        a(1,j)=  bord
        a(m+2,j)=bord
 2200 continue
c
c  Decide on the size of the map; it is proportional to the dimensions
c  unless otherwise requested
      call getval('height', hw(2), 1, nf)
      call getval('width',  hw(1), 1, nf)
      w=hw(1)
      h=hw(2)
      if (h .le. 0 .and. w .eq. 0) then
         if (m .ge. n) w=6.0
         if (m .lt. n) h=6.0
      endif
      if (w .le. 0) w=h*(m-1)/(n-1.0)
      if (h .le. 0) h=w*(n-1)/(m-1.0)
c
c  Set the origin.
c
c  If the origin of this plot is explicitly set, move it.
c  External units are 1/1000 inch for compatibility with pscrip.
c  Program units are inches.
      c=1000
c
      call getval('plot', xyorg, 2, nf)
      if (nf .eq. 2) then
        write(9,'(2f9.2,a)') 
     $  c*xyorg(1), c*xyorg(2), ' translate'
        xynew(1)=w
        xynew(2)=-xyorg(2)
      else
c  No explicit origin requested.  Set standard position.
        write(9,'(2f9.2,a)') 
     $  c*xynew(1)+c, c*xynew(2)+c,' translate'
        xynew(1)=w
        xynew(2)=-1.0
      endif
c
c  Plot label if there is one.
      dy=0.0
      call getchr('label', label, nf)
c
      hlet=int(0.5*h + 9.0)/72.0
      if (nf .eq. 1) then
        if (info .ge. 1) write(iout,'(/2a)') ' Label: ',label(1:72)
        dy=dy - 2.0*hlet
        call letter(0.0, dy, hlet, 0.0, label)
      endif
c
c
c  Paint the array 
      if (info .ge. 1) write(iout,'(/a)') ' Painting underway ...'
c
      call paint(m, n, a, zlevs, w, h)
c
      if (info .ge. 1) write(iout,'(/a,i5)') 
     $' Number of closed contours in map ',loops
c
c  Add extra xy-lines
      call xyline(w, h)
c
c  Draw a border around the map or mask out around inscribed ellipse
      call getchr('border', boff, nbor)
      if (nbor .eq. 0) boff='on'
      call getval('weight', weight, 1, nwt)
      if (boff .eq. 'ma') then
        call border(0.0, 3)
        call border(weight(1), 2)
      elseif (boff .eq. 'on') then
        call border(weight(1), min(map,2))
      endif
c
c  Draw a color bar to right of main graph if not suppressed
      call getchr('nobar', onoff, nbar)
      if (nbar .eq. 0) onoff='on'
      if (onoff .ne. 'of') return
      write(9,'(2f9.1,a)') c*(w+hlet), 0.0, ' translate'
      call bar(min(5.0, h), hlet)
      write(9,'(2f9.1,a)') -c*(w+hlet), 0.0, ' translate'
c
      return
      end
c______________________________________________________________
      subroutine paint(m, n, a, zlevs, w, h)
c$$$$ calls dumpit,getval,glevel,sort,tensor
c  Jacket routine for performing basic contouring function.
c  As always,  a  is the array with original dimensions m, n.
c  zlevs is an array of contour levels; the list must be
c    in ascending numerical order.  Routine quits by detecting
c    a decrease.
c  h, w  are height and width in inches of finished map.
      save outln,joutln
      parameter (lpmx=250000, knmx=300000)
      dimension a(*),zlevs(*),basx(103),basy(103),key(lpmx)
      dimension outln(lpmx)
      integer*2 kxy
      common /perim/ ltrue(lpmx)
      common /arcs/ loops,istart(lpmx),area(lpmx),lev(lpmx),kxy(2,knmx)
      common /trace/ level,em,en,xfac,yfac
      common /xtreme/ bord,amin,amax,anull(2),alim(3),colim(2)
      parameter (levmx=50)
      common /noir/ scutum,kolors,art(4,levmx),kart(levmx),loutln(levmx)
      data joutln/-1/
c
c  Inquire about outlines
      call getval('outline', outln, 20, noutln)
      if (noutln .ge. 0) then
         joutln=noutln
         do 1016 k=1,kolors
 1016    loutln(k)=abs(noutln)
      endif
c  loutln=0 => outline that level
      do 1005 k=1,  kolors
       do 1002 i=1, noutln
         if (abs(zlevs(k)-outln(i)) .le. 1e-4*abs(zlevs(k)+outln(i)))
     $   loutln(k)=0
 1002   continue
 1005 continue
c
c  Inquire about dashed outlines - marker in loutln set to -1
      call getval('dashed', outln, 20, noutln)
      if (noutln .ge. 0)  joutln=noutln
c  loutln= -1 => dash outline that level
      do 1015 k=1,  kolors
       if (noutln .eq. 0) loutln(k)=-1
       do 1012 i=1, noutln
         if (abs(zlevs(k)-outln(i)) .le. 1e-4*abs(zlevs(k)+outln(i)))
     $   loutln(k)=-1
 1012   continue
 1015 continue
c
c  Set scale factors which are single grid steps in x and y
c  and dimensions for dumpit
      c=1000
      xfac=c*w/(m-1)
      yfac=c*h/(n-1)
      em=m
      en=n
c
c  Establish map transformations if any
      call tensor
c
c  Offset the map by one cell width for border
      write(9,'(2f10.1,a)') -xfac,-yfac,' translate'
c
c  Load basx, basy with a bounding rectangle;
c  y values are closely spaced for Aitoff projection.
      do 1100 i=1, 51
        basx(i)=em + 1.0
        basy(i)=(en + 1.0)*(1.0 - 0.02*(i-1))
        basx(i+51)=0.0
        basy(103-i)=basy(i)
 1100 continue
c  Determine the base color
      do 1300 level=0, kolors-1
        if (zlevs(level+1) .gt. amin) goto 1310
 1300 continue
c  Fill rectangle with  base color
c1310 level=1
c     call dumpit(zlevs(1), 102, basx,basy)
c     area(1)=1.5*area(1)

c ************************ quickfix *******************************
 1310      call dumpit(zlevs(level), 102, basx,basy)
      area(level)=1.5*area(level)

c
c  Set 0.10 inches to be the maximum step on any contour:
      ds=0.10*c/min(xfac, yfac)
c  Run through contour levels, saving paths in  kxy.
c  Save time and memory by skipping useless levels
      do 1600 level=2, kolors
        zlv=zlevs(level)
        if (zlv .ge. amax) goto 1610
        if (zlv .gt. bord) then
          call glevel(m+2, m+2, n+2, a, ds, zlv)
        endif
 1600 continue
 1610 continue
c
c  Sort the contours path into decreasing order by area.
c  Since sort makes ascending lists, numerically area < 0
      call sort(loops, area, key)
c
c  Output the paths in order of decreasing area
      do 2800 lk=1, loops
        l=key(lk)
        level=lev(l)
        nxy=istart(l+1)-istart(l)
        j1=istart(l)   + 1
        j2=istart(l+1) - 1
        ka=kart(level)
        lout=loutln(ltrue(l))
c  Postscript code written to unit 9; each loop annotated with a header
        write(9,'(a,i5,a,i3,a,f9.1,a,g12.4/3f9.3,a)') '%% nxy ',nxy,
     $  '  color number',level,'  area', -area(lk),
     $  '  true level',zlevs(ltrue(l)),
     $  art(2,ka),art(3,ka),art(4,ka),' sethsbcolor'
        write(9,'(2i7,a)') kxy(1,j1-1),kxy(2,j1-1),' m'
        write(9,*) (kxy(1,j) - kxy(1,j-1), 
     $              kxy(2,j) - kxy(2,j-1), ' r',j=j1,j2)
        if (lout .gt. 0) then
          write(9,'(a)') 'closepath fill'
c  Outline region with a black line
        elseif (lout .eq. 0) then
          write(9,'(a)')'closepath gsave fill grestore 0 setgray stroke'
        else
          write(9,'(a)')'closepath gsave fill grestore 0 setgray '//
     $    '[50 50] 0 setdash stroke [] 0 setdash'
c
c
*  A more subtle outliner - hardcopy not up to it though!
*         kb=ltrue(l)
*         write(9,'(3f7.3,a)') art(2,kb+1),art(3,kb+1),
*    $    art(4,kb+1),' sethsbcolor stroke'
*  An alternate that is pretty for grays
*    $    max(0.0,art(4,kb)-0.3),' setgray stroke'
        endif
 2800 continue
c
c  Restore origin
      write(9,'(2f10.1,a)')  xfac, yfac,' translate'
      return
      end
c____________________________________________________________________
      subroutine xyline(w, h)
c$$$$ calls  getchr,getval
c  Inputs then immediately plots xy-line data from a file or
c  series of files; establishes scale through the axes command.
c
      character*80 list, mark*2
      parameter (nxymx=17270)
      save xy,axes,nxy
      dimension axes(4),xy(nxymx)
      common /inout/ inp,iout,inf,info
      data axes/0,0,0,0/, nax/-99/, nxy/0/
c
c
c  Execute the line command
      call getchr('lines', list, nlist)
      if (nlist .eq. 0) nxy=0
      if (nlist.le.0 .and. nxy.eq.0) return
c  Open a new file if one is named, otherwise use old data if present
      if (nlist .eq. 1) then
        open (unit=11, file=list, status='OLD', err=3000)
        do 1050 j=1, nxymx, 2
          read (11,*, end=1100, err=3100) xy(j),xy(j+1)
 1050   continue
        j=nxymx
        write (iout,'(a,i5,a)')
     $  '>>> x-y line series truncated to ', nxymx/2,' terms'
 1100   close(unit=11)
        nxy=j-1
        write(iout,'(a,i5)')
     $  ' x-y line data read; number of points:',nxy/2
      else
        write(iout,'(a)') ' Old x-y line data plotted on this map'
      endif
c
c  Check if the axes have been defined
      call getval('axes', axes, 4, nax)
c
      if (axes(1).ne.axes(2) .and. axes(3).ne.axes(4)) then
        c=1000
        xfac=c*w/(axes(2) - axes(1))
        yfac=c*h/(axes(4) - axes(3))
        write(9,*)'/l{lineto}def 0 setgray'
      else
        write(iout,'(a)')
     $  '>>> The axes command is needed to provide a scale for lines',
     $  '    x-y line data can not be plotted'
        return
      endif
c
c  Write the scaled lines out to 9; break line if point goes outside box
      write (9,*)'% Begin x-y line data'
      mark=' m'
      do 1200 j=1, nxy, 2
        if ((xy(j  )-axes(2))*(xy(j  )-axes(1)).gt.0.0 .or.
     $      (xy(j+1)-axes(4))*(xy(j+1)-axes(3)).gt.0.0) then
          if (mark .eq. ' l') write(9,*)'stroke'
          mark=' m'
        else
          kx=xfac*(xy(j  ) - axes(1))
          ky=yfac*(xy(j+1) - axes(3))
          write (9,*) kx,ky,mark
          mark=' l'
        endif
 1200 continue
      if (mark .eq. ' l') write(9,*)'stroke'
      return
c
c  Error conditions
 3000 write(iout,'(a,a)')'>>> Nonexistent file: ',list
      return
 3100 write(iout,'(a,a)')
     $'>>> Error reading x-y line data in file: ',list
      return
      end
c______________________________________________________________________
      subroutine border(weight, kind)
c$$$$ calls no other routines
c  Draws a border around the finished map
c  weight  is line width in 1/1000th inches
      common /trace/ level,em,en,xfac,yfac
      common /atlas/ map,mtab,ntab,xtab(201),ytab(201)
c
c  Define sizes
      a=0.5*(em - 1.0)*xfac
      b=0.5*(en - 1.0)*yfac
      wt=abs(weight)
c
c  Choose appropriate shape depending on the map
      goto (1000, 2000, 3000), kind
c
c  Map has rectangular border
 1000 write(9,*) '% Rectangular border'
      write(9,*) 'gsave 0 setgray ',wt,' setlinewidth'
      write(9,*) 0,0,' m',2*a,0,' r',0,2*b,' r',-2*a,0,' r'
      write(9,*) 'closepath stroke grestore'
      return
c
c  Elliptical border - drawn by the PostScript arc command
 2000 write(9,*) '% Elliptical border'
      write(9,*) 'gsave',a, b, ' translate 1 ',b/a,' scale '
      write(9,*) '0 0',a+2,' 0 360 arc'
      write(9,*) wt,' setlinewidth 0 setgray stroke grestore'
      return
c
c  Mask out stuff between the inscribed ellipse and the rectangle
 3000 write (9,*) 'gsave', a,b,' translate',a+4,b+4,' scale'
      write (9,*) '0 0 0.9999 0 360 arc 0 -1 r -2 0 r 0 2 r 2 0 r'
      write (9,*) '0 -1 r closepath 1 setgray fill grestore'
      return
c
      end
c________________________________________________________________________
      subroutine bar(height, hlet)
c$$$$ calls letter,mabel
c  Draws the color key to the right of the map.  This involves
c  numerical annotation at the proper place done by mabel.
c
      character*20 label
c
      common /xtreme/ bord,amin,amax,anull(2),alim(3),colim(2)
      parameter (levmx=50)
      common /noir/ scutum,kolors,art(4,levmx),kart(levmx),loutln(levmx)
c
      common /inout/ inp,iout,inf,info
c
      c=1000
      art1=art(1,kart(1))
      kk=kart(kolors)
      cons=0.9*c*height/(1.0e-18 + (art(1,kk) - art1))
      dx=2.0*c*hlet
c  First paint the highest color; just paint the rectangle
c  in the proper color and fill
      dz=c*height
      write(9,*) '% Color bar'
      write(9,'(4(a,f8.0))') '0 0 m',dx,' 0 r 0',dz,' r',-dx,' 0 r'
      write(9,'(a,3f10.3,a)') 'closepath ',
     $art(2,kk),art(3,kk),art(4,kk),' sethsbcolor fill'
c  Now do the rest
      do 1200 kl=kolors, 2, -1
        ka=kart(kl)
        dz=cons*(art(1,ka) - art1)
        write(9,'(4(a,f8.0))') '0 0 m',dx,' 0 r 0',dz,' r',-dx,' 0 r'
        ka=kart(kl-1)
        write(9,'(a,3f10.3,a)') 'closepath ',
     $  art(2,ka),art(3,ka),art(4,ka),' sethsbcolor fill'
c  Take care of outline marker
c       if (loutln(kl) .eq. 0) write(9,'(a,f8.0,a,f8.0,a)')
c    $     '0 ',dz,' m',dx,' 0 r 0 setgray stroke %outliner'
c       if (loutln(kl) .lt. 0) write(9,'(a,f8.0,a,f8.0,a)')
c    $     '0 ',dz,' m',dx,' 0 r 0 setgray [50 50] 0 setdash stroke' //
c    $     ' [] 0 setdash  % dashed outliner'
        write(9,'(a,f8.0,a,f8.0,a)')
     $     '0 ',dz,' m',dx,' 0 r 0 setgray stroke %outliner'
 1200 continue
      kn=ka
c  Surround the bar with a border
      write(9,'(4(a,f8.0))')
     $'0 0 m',dx,' 0 r 0',height*c,' r',-dx,' 0 r'
      write(9,'(a)'),'0 setgray closepath stroke'
c
c  Write numerical annotation to the right
      write(9,'(a)') '0 setgray'
      dx=dx + c*hlet
      larg=log10(max(abs(art(1,kk)), abs(art1)))
      if (larg .lt. 0) larg=larg - 1
      scale=1.0
c  If numbers are too large or small inmagnitude, scale them 
      if (larg .ge. 5 .or. larg .le. -2) then
        scale=10.0**larg
        dz=cons*(art(1,kk) - art1) + 0.75*c*hlet
c  Write scale factor in exponential notation above the list
        call letter(dx/c, dz/c, hlet, 0.0, 'x10')
        call mabel(real(larg), klen, label)
        call letter(dx/c+1.85*hlet, dz/c+0.5*hlet, 0.75*hlet, 0.0,
     $              label(1:klen))
      endif
c
      do 1500 ka=1, kolors
        dz=cons*(art(1,ka) - art1) - 0.5*c*hlet
        if (abs(art(1,ka)) .le. 0.0001*(art(1,kolors)-art(1,1)))
     $  art(1,ka)=0.0
        if (ka .ne. kn) then
          call mabel(art(1,ka)/scale, klen, label)
          call letter(dx/c, dz/c, hlet, 0.0, label(1:klen))
        endif
 1500 continue
c
      return
      end
c_______________________________________________________________________
      subroutine letter(x, y, h, angle, text)
c$$$$ calls no other routines
      character*(*) text
c  A postscript version of the famous routine, without Greek or
c  subscript ability.  
c  External units are reset to points (1/72 inches);
c  Program units as always are inches.
c
      long=len(text)
      do 1100 l=long, 1, -1
        if (text(l:l) .ne. ' ') goto 1101
 1100 continue
      return
 1101 continue
c
      ipoint=h*72
      write(9,'(a)')'gsave 15.0 13.89 scale 0 setgray',
     $'/Helvetica findfont'
c
      write(9,'(i4,a/2f6.1,a)')
     $ipoint,' scalefont setfont',
     $67*x, 72*y, ' moveto currentpoint translate'
      if (angle .ne. 0) write(9,'(f8.2,a)') angle,' rotate'
c
      write(9,'(3a)') '(',text(1:l),') show'
c
      write(9,'(a)') 'grestore'
      return
      end
c_______________________________________________________________
      subroutine table
c$$$ calls getchr
c  Reads in a palette from a file, substituting it for
c  the standard palette number 1.  Always reads to EOF
c
      parameter (nk=28)
      character*64 name
      common /inout/ inp,iout,inf,info
      common /pallet/ many,npal(10),hue(nk,10),sat(nk,10),bri(nk,10)
c
c  Look for filename of a color table
      call getchr('table', name, ntb)
      if (ntb .le. 0) return
      open (unit=10, file=name, status='OLD', err=2000)
c
c  Read into the first palette
      bri(1,1)=0.0
      do 1100 it=2, nk
        read (10,*,end=1110,err=2100) hue(it,1),sat(it,1),bri(it,1)
 1100 continue
      it=nk + 1
 1110 it=it - 1
      npal(1)=it
      write(iout, '(/a,i3,a)')
     $' Palette 1 has been replaced by a new selection of ',it,' colors'
      return
c
c  Errors reported
 2000 write(iout, '(a,a/a)')'>>> File ',name,
     $'is nonexistent or you lack permission to read it'
      return
 2100 write(iout, '(2a)')'>>> Unreadable numbers in file ', name,
     $'Palette 1 will be a mixture of old and new colors'
      return
      end
c_______________________________________________________________________
      subroutine minmax(mdim, n, k, x, xmin, xmax)
c$$$$ calls no other routines
c  Finds minimum and maximum of an array  x  with actual dimensions
c  n, k  held in columns that are mdim long
c  k.  
      dimension x(mdim,n)
      xmin=x(1,1)
      xmax=xmin
      do 1100 i=1, n
        do 1000 j=1, k
          xmin=min(xmin, x(i,j))
          xmax=max(xmax, x(i,j))
 1000   continue
 1100 continue
      return
      end
c______________________________________________________________________
      subroutine sort(no, x, key)
c$$$$ calls no other routines
c  In-place rapid sorter.  Sorts array in place and saves an index to
c  the sort in key.
      dimension x(*), key(*)
c
      do i=1,no
         key(i)=i
      enddo
      mo=no
 2    if(mo.le.15) then
        if (mo.le.1) return
        mo=2*(mo/4) + 1
      else
        mo=2*(mo/8) + 1
      end if
      ko=no - mo
      jo=1
 25   i=jo
 26   if (x(i).le.x(i+mo)) goto 28
      temp=x(i)
      x(i)=x(i+mo)
      x(i+mo)=temp
      kemp=key(i)
      key(i)=key(i+mo)
      key(i+mo)=kemp
      i=i - mo
      if (i.ge.1) goto 26
 28   jo=1 + jo
      if (jo.le.ko) goto 25
      goto 2
      end
c______________________________________________________________________
*===================================  Map generator and page manager END
*=======================================================================
*=======================================================================
* Color palette data base BEGIN==================================
*
      blockdata artist
c  Sets the color attributes of the various palette and default color
c  schemes.  Setting the variables in /pallet/ is the main task.
c
      common /local/ color(1),black(2)
c
      parameter (levmx=50)
      common /noir/ scutum,kolors,art(4,levmx),kart(levmx),loutln(levmx)
c
      common /pallet/ many,npal(10),hue(28,10),sat(28,10),bri(28,10)
c
      data color/0/,  black/ 0.7, 2.0/
      data kolors/0/, art/levmx*1.0,levmx*1.0,levmx*1.0,levmx*1.0/
c
      data many/6/
c
c  Palette 1:  low cool blue to high hot red 
      data npal(1)/16 /
      data (hue(j,1),sat(j,1),bri(j,1), j=1, 16)/
     $0.600,1.000,0.500, 0.600,1.000,0.600, 0.600,1.000,0.700,
     $0.600,1.000,1.000, 0.600,0.800,1.000, 0.600,0.700,1.000,
     $0.600,0.500,1.000, 0.600,0.300,1.000, 1.000,0.100,1.000,
     $1.000,0.300,1.000, 1.000,0.350,1.000, 0.900,0.500,1.000,
     $1.000,0.550,1.000, 1.000,0.600,1.000, 1.000,1.000,1.000,
     $1.000,0.500,0.800/
c
c  Palette 2:  blue-green-yellow-orange-brown-red-lilac
      data npal(2)/24 /
      data (hue(j,2),sat(j,2),bri(j,2), j=1, 24)/
     $0.600,1.000,0.500,0.600,1.000,0.700,0.600,1.000,1.000,
     $0.550,1.000,0.800,0.500,1.000,0.700,0.500,1.000,0.800,
     $0.450,1.000,0.800,0.400,1.000,0.800,0.400,1.000,1.000,
     $0.300,0.600,1.000,0.250,0.600,1.000,0.200,0.600,1.000,
     $0.150,0.300,1.000,0.100,0.400,1.000,0.100,0.800,1.000,
     $0.100,0.900,1.000,0.100,0.5,0.800,0.100,1.000,0.800,
     $0.000,1.000,0.900,0.000,0.5,0.900,0.000,0.500,1.000,
     $0.000,0.400,1.000,0.000,0.300,1.000,0.000,0.200,1.000/
c
c  Palette 3: lilac-blue-green-yellow-orange (pastel)
      data npal(3)/28/
      data (hue(j,3),sat(j,3),bri(j,3), j=1, 28)/
     $0.00,0.00,0.90, 0.90,0.30,1.00, 0.80,0.30,0.90, 0.80,0.40,0.90,
     $0.80,0.60,1.00, 0.70,0.40,1.00, 0.70,0.30,1.00, 0.60,0.30,1.00,
     $0.48,0.30,1.00, 0.48,0.40,1.00, 0.40,0.50,1.00, 0.47,1.00,1.00,
     $0.40,0.70,1.00, 0.30,0.50,1.00, 0.20,1.00,1.00, 0.20,0.80,1.00,
     $0.20,0.40,1.00, 0.20,0.20,1.00, 0.00,0.20,1.00, 0.00,0.25,1.00,
     $0.00,0.35,1.00, 0.00,0.40,1.00, 0.00,0.45,1.00, 0.00,0.55,1.00,
     $0.00,0.60,1.00, 0.00,0.90,1.00, 0.00,1.00,0.80, 0.00,1.00,0.70/
c
c  Palette 4: the Harvard palette dark blue-light blue-yellow-brown
      data npal(4)/24/
      data (hue(j,4),sat(j,4),bri(j,4), j=1, 24)/
     $ 0.60,1.00,0.40, 0.60,0.90,0.50, 0.60,0.70,0.50, 0.60,1.00,0.81,
     $ 0.60,0.70,0.70, 0.60,1.00,1.00, 0.60,0.75,1.00, 0.60,0.70,1.00,
     $ 0.60,0.55,1.00, 0.60,0.40,1.00, 0.60,0.30,1.00, 0.55,0.25,1.00,
     $ 0.1,.4,1, 0.1,0.4,0.9, 0.1,.8,1, 0.10,0.90,1.00,
     $ 0.10,1.00,0.90, 0.00,0.60,1.00, 0.00,0.85,1.00, 0.00,0.50,0.80,
     $ 0.00,1.00,0.70, 0.0,.5,.5, 0.00,1.00,0.60, 0.00,0.50,0.40/
c
c  Palette 5: another attempt at palette 1
      data npal(5)/20/
      data (hue(j,5),sat(j,5),bri(j,5), j=1, 20)/
     $ 0.60,1.00,0.40,0.60,0.70,0.50,0.60,1.00,0.81,0.60,0.70,0.70,
     $ 0.60,1.00,1.00,0.60,0.75,1.00,0.60,0.70,1.00,0.60,0.40,1.00,
     $ 0.60,0.30,1.00,0.55,0.25,1.00,0.90,0.15,1.00,0.90,0.25,1.00,
     $ 0.90,0.35,1.00,0.90,0.45,1.00,0.90,0.65,1.00,0.90,0.95,1.00,
     $ 1.00,1.00,1.00,1.00,0.50,0.70,1.00,1.00,0.70,1.00,1.00,0.50/
c
c  Palette 6: Another attempt at low blues through greens, yellow,
c  orange, to hot reds.
      data npal(6)/12/
      data (hue(j,6),sat(j,6),bri(j,6), j=1, 12)/
     $ 0.666,0.378,1.000,0.550,0.478,1.000,0.500,0.578,1.000,
     $ 0.450,0.678,1.000,0.400,1.000,0.933,0.239,0.600,1.000,
     $ 0.100,0.767,0.933,0.061,0.800,0.889,0.034,0.900,0.889,
     $ 0.005,1.000,0.889,0.0,0.5,0.7,0.0,0.5,0.4/
      end
c_______________________________________________________________
*=========================================== Color palette data base END
*=======================================================================

